
 	MACRO NPC id,sadr,aadr
 	 db id
 	 ds 9
 	 dw sadr,aadr
 	 ds 18
 	ENDM
 	
 	MACRO SPRITE dx,dy,adr,flag
 	 db dx,dy
 	 dw adr
 	 db flag
 	ENDM
 	
; NPC structure:
; 0		id
; 1		map
; 2		coord
; 3		cur.sprite
; 4		cur.animation
; 5		health
; 6		experience, b7..4 = strength
; 7,8,9		bag (items.id)
; 10,11		sprites tab adr
; 12,13		animations tab adr
; 14		anim counter
; 15		tile under npc
; 16		* old map
; 17		* old coord
; 18		* old tile under
; 19		* new map
; 20		* new coord
; 21,22		current anim adr
; 23,24		loop.adr
; 25		spr dx
; 26		spr dy
; 27,28		spr.adr
; 29		flags
;		b7 : sprite is drawn on screen
;		b4 : shift up
;		b3 : shift left
; 30,31		scr.adr

; ---------------------------------------------------------------------------
exeExt00:	cp	maxExt0func
		ret	nc
sub_C003:	push	hl
loc_C004:	ld	hl, ext0funcTab
		add	a, a
loc_C008:	add	a, l
		ld	l, a
		jr	nc, loc_C00D
		inc	h
loc_C00D:	ld	a, (hl)
		inc	hl
		ld	h, (hl)
		ld	l, a
		ex	(sp), hl
		ret
		
ext0funcTab:	dw initData	; 00: init
		dw Animate	; 01: exec animation cycle
		dw npcSetAnim	; 02: set anim C to npc B
		dw setNpcSpr	; 03: set sprite C to npc B
		dw drawAll	; 04: put npc & items on map
		dw removeAll	; 05: remove npc & items from map
		dw npcCheckFront; 06: get tile/npc/item in front of npc B; CY=1: no place in front (end of map)
		dw npcGetAnim	; 07: C = anim.nr of npc B
		dw npcGetSprite	; 08: C = sprite.nr of npc B
		dw waitNpc	; 09: wait npc B animation end
		dw drawBag	; 0A: draw bag
		dw putInBag	; 0B: put item C in bag; CY=1: error
		dw delFromBag	; 0C: delete item C from bag
		dw extGetCurItem; 0D: C = current item ID
		dw extCheckItem	; 0E: Z=1 if item C is in bag
		dw dropItem	; 0F: drop item C from bag to map D crd E
		dw addItem	; 10: add item C to bag
		dw moveNpc	; 11: move npc B to map H crd L, set spr D, ani E
		dw findNpc	; 12: IX = dsc NCP B (CY=1:not found)
		dw incStrength	; 13: add 1 stength
		dw extDamage	; 14: sub D health from NPC B
		dw loc_C057	; 15: ???
maxExt0func	equ ($ - ext0funcTab) / 2
; ---------------------------------------------------------------------------
extDamage:	push	ix
		push	de
		call	findNpc
		call	c, fatalErr
		pop	de
		ld	a, (ix+5)
		sub	d
		jr	nc, loc_C050
		xor	a
loc_C050:	ld	(ix+5),	a
		ld	d, a
		pop	ix
		ret
; ---------------------------------------------------------------------------
loc_C057:	push	ix
		ld	ix, npcTab
		ld	a, (ix+6)
		and	0Fh
		jr	loc_C073
		
incStrength:	push	ix
		ld	ix, npcTab
		ld	a, (ix+6)
		cp	0F0h
		jr	nc, loc_C07D
		add	a, 10h
loc_C073:	ld	(ix+6),	a
		ld	d, 0
		ld	a, 0Eh
		call	ovEngineFunc
loc_C07D:	pop	ix
		ret
; ---------------------------------------------------------------------------
; move npc B to map H crd L, set spr D, ani E
moveNpc:	ld	a, h
		ld	(byte_C0A9), a
		ld	a, l
		ld	(byte_C0AA), a
		ld	a, d
		ld	(byte_C0AB), a
		ld	a, e
		ld	(byte_C0AC), a
		call	findNpc
		ld	hl, unk_C0A8
		ld	(ix+4),	0FFh
		ld	(ix+15h), l
		ld	(ix+16h), h
		ld	(ix+0Eh), 1
		dec	(ix+4)
		ret
; ---------------------------------------------------------------------------
unk_C0A8:	db 0F5h
byte_C0A9:	db 0
byte_C0AA:	db 0
byte_C0AB:	db 0
byte_C0AC:	db 0
; ---------------------------------------------------------------------------
initData:	ld	a, 0FFh
		ld	(curMapNr), a
		ld	hl, npcInitTab		; 1.init npc
loc_C0B5:	ld	a, (hl)
		ld	b, a
		rla
		jr	c, loc_C0F3
		call	findNpc
		call	c, fatalErr
		inc	hl
		ld	a, (hl)
		ld	(ix+1),	a
		inc	hl
		ld	a, (hl)
		ld	(ix+2),	a
		inc	hl
		ld	c, (hl)
		inc	hl
		push	hl
		call	npcSetSprite
		pop	hl
		ld	c, (hl)
		inc	hl
		push	hl
		call	setAnim
		pop	hl
		ld	(ix+5),	1Fh
		ld	(ix+6),	0
		ld	(ix+7),	0
		ld	(ix+8),	0
		ld	(ix+9),	0
		ld	(ix+0Eh), 1
		jr	loc_C0B5

loc_C0F3:	ld	hl, itemsTab		; 2. move all items to map 200
loc_C0F6:	ld	a, (hl)
		rla
		jr	c, loc_C104
		inc	hl
		ld	(hl), 0C8h
		inc	hl
		ld	(hl), 1
		inc	hl
		inc	hl
		jr	loc_C0F6

loc_C104:	ld	ix, itemInitTab		; 3. place items on map
loc_C108:	ld	a, (ix+0)
		bit	7, a
		ret	nz
		ld	c, a
		ld	hl, itemsTab
loc_C112:	ld	a, (hl)
		rla
		jp	c, fatalErr
		rra
		cp	c
		inc	hl
		jr	z, loc_C121
		inc	hl
		inc	hl
		inc	hl
		jr	loc_C112
loc_C121:	ld	b, (ix+1)
		ld	c, (ix+2)
		ld	(hl), b
		inc	hl
		ld	(hl), c
		inc	ix
		inc	ix
		inc	ix
		jr	loc_C108
		
; ---------------------------------------------------------------------------

Animate:	ld	ix, npcTab
loc_C136:	ld	a, (ix+0)
		inc	a
		ret	z
		ld	c, (ix+3)
		inc	c
		jr	z, loc_C177
		dec	c
		ld	a, (ix+4)
		inc	a
		jr	z, loc_C160
		dec	(ix+0Eh)
		jr	nz, loc_C177
		ld	l, (ix+15h)
		ld	h, (ix+16h)
		ld	a, (hl)
		inc	hl
		sub	0F0h
		jr	nc, aniComs
		add	a, 0F0h
		ld	(ix+0Eh), a
		ld	c, (hl)
		inc	hl
loc_C160:	push	hl
		ld	a, c
		cp	(ix+3)
		jr	nz, loc_C16D
		bit	7, (ix+1Dh)
		jr	nz, loc_C170
loc_C16D:	call	npcSetSprite
loc_C170:	pop	hl
loc_C171:	ld	(ix+15h), l
		ld	(ix+16h), h
loc_C177:	ld	de, 20h
		add	ix, de
		jr	loc_C136

aniComs:	push	hl
		ld	hl, loc_C193
		ex	(sp), hl
		push	hl
		ld	hl, aniComTab
		add	a, a
		add	a, l
		ld	l, a
		jr	nc, loc_C18D
		inc	h
loc_C18D:	ld	a, (hl)
		inc	hl
		ld	h, (hl)
		ld	l, a
		ex	(sp), hl
		ret
loc_C193:	ld	(ix+0Eh), 1
		jr	loc_C171

aniComTab:	dw aniF0, aniF1, aniF2, aniF3
		dw aniF4, aniF5, aniF6, aniF7
		dw aniF8, aniF9, aniFA, aniFB
		dw aniFC, aniFD, aniFE, aniFF

; F0	remove NPC (set sprite FF)

aniF0:		push	hl
		call	restTile
		call	aniF4
		call	restBG
		pop	hl
		ld	(ix+3),	0FFh
		ret
	
; FF	stop animation
aniFF:		ld	(ix+4),	0FFh
		ret
		
; F5,map,crd,spr,anim
; move to map,crd, set spr and anim

aniF5:		ld	b, (hl)
		inc	hl
		ld	c, (hl)
		inc	hl
		ld	d, (hl)
		inc	hl
		ld	e, (hl)
		inc	hl
		push	hl
		push	de
		ld	a, 7
		call	ovEngineFunc
		ld	a, d
		pop	de
		pop	hl
		ld	(ix+13h), b
		ld	(ix+14h), c
		push	de
		call	aniF7
		call	aniF6
		call	aniF4
		pop	de
		push	de
		ld	c, d
		call	npcSetSprite
		pop	bc
		jp	setAnim

; F9/FA/FB/FC : move to up/down/left/right

aniF9:		xor	a
		jr	loc_C207
aniFA:		ld	a, 1
		jr	loc_C207
aniFB:		ld	a, 2
		jr	loc_C207
aniFC:		ld	a, 3
loc_C207:	push	hl
		call	getInFront
		jr	c, loc_C22A
		inc	h
		jr	nz, loc_C22A
		inc	l
		jr	nz, loc_C22A
		cp	0F0h
		jr	nc, checkDoors
		rla
		jr	c, loc_C22A
		ld	(ix+13h), d
		ld	(ix+14h), e
		pop	hl
		ld	e, (hl)
		inc	hl
		ld	a, b
		cp	d
		ld	d, 0
		ret	z
		add	hl, de
		ret
loc_C22A:	pop	hl
		ld	a, (heroId)
		cp	(ix+0)
		jp	z, aniFF
		dec	hl
		ret

; in	D,E = map,coord to check
; out	+19,20 = new place, b5,6,flag = 1
checkDoors:	ld	hl, doorsTab
loc_C239:	ld	a, (hl)
		cp	0FFh
		jr	z, loc_C22A
		cp	d
		inc	hl
		ld	a, (hl)
		inc	hl
		jr	nz, loc_C247
		cp	e
		jr	z, loc_C24B
loc_C247:	inc	hl
		inc	hl
		jr	loc_C239
loc_C24B:	ld	a, (hl)
		ld	(ix+13h), a
		inc	hl
		ld	a, (hl)
		ld	(ix+14h), a
		set	5, (ix+1Dh)
		set	6, (ix+1Dh)
		call	aniOff
		jr	loc_C22A
; ---------------------------------------------------------------------------
; doors : map1, coord1 -> map2, coord2

doorsTab:	db 5, 1Bh, 0Ah,	33h
		db 0Ah,	3Bh, 5,	23h
		db 8, 1Dh, 9, 0Ch
		db 9, 4, 8, 25h
		db 17h,	15h, 22h, 33h
		db 22h,	3Bh, 17h, 1Dh
		db 17h,	2Fh, 23h, 32h
		db 23h,	3Ah, 17h, 37h
		db 17h,	2Bh, 24h, 34h
		db 24h,	3Ch, 17h, 33h
		db 1Ch,	14h, 25h, 33h
		db 25h,	3Bh, 1Ch, 1Ch
		db 1Fh,	32h, 26h, 33h
		db 26h,	3Bh, 1Fh, 3Ah
		db 1Eh,	35h, 27h, 33h
		db 27h,	3Bh, 1Eh, 3Dh
		db 26h,	21h, 28h, 2Bh
		db 28h,	33h, 26h, 29h
		db 2Dh,	33h, 3Bh, 32h
		db 3Bh,	3Ah, 2Dh, 3Bh
		db 2Dh,	37h, 3Dh, 34h
		db 3Dh,	3Ch, 2Dh, 3Fh
		db 2Eh,	36h, 3Fh, 32h
		db 3Fh,	3Ah, 2Eh, 3Eh
		db 30h,	13h, 40h, 32h
		db 40h,	3Ah, 30h, 1Bh
		db 2Fh,	11h, 3Ch, 33h
		db 3Ch,	3Bh, 2Fh, 19h
		db 2Fh,	16h, 3Eh, 33h
		db 3Eh,	3Bh, 2Fh, 1Eh
		db 37h,	1Ch, 41h, 32h
		db 41h,	3Ah, 37h, 24h
		db 37h,	35h, 42h, 34h
		db 42h,	3Ch, 37h, 3Dh
		db 3Ah,	0Ch, 43h, 32h
		db 43h,	3Ah, 3Ah, 14h
		db 3Ah,	25h, 44h, 32h
		db 44h,	3Ah, 3Ah, 2Dh
		db 39h,	9, 45h,	32h
		db 45h,	3Ah, 39h, 11h
		db 4Bh,	0Ch, 51h, 34h
		db 51h,	3Ch, 4Bh, 14h
		db 52h,	5, 56h,	35h
		db 56h,	3Dh, 52h, 0Dh
		db 53h,	2, 55h,	32h
		db 55h,	3Ah, 53h, 0Ah
		db 4Fh,	13h, 50h, 33h
		db 50h,	3Bh, 4Fh, 1Bh
		db 48h,	2, 57h,	33h
		db 57h,	3Bh, 48h, 0Ah
		db 48h,	1Ah, 58h, 33h
		db 58h,	3Bh, 48h, 22h
		db 48h,	31h, 59h, 33h
		db 59h,	3Bh, 48h, 39h
		db 48h,	1Eh, 5Bh, 33h
		db 5Bh,	3Bh, 48h, 26h
		db 4Ch,	19h, 5Ah, 32h
		db 5Ah,	3Ah, 4Ch, 21h
		db 4Ch,	32h, 5Ch, 34h
		db 5Ch,	3Ch, 4Ch, 3Ah
		db 51h,	4, 54h,	34h
		db 54h,	3Ch, 51h, 0Ch
		db 0FFh

; C = npc B sprite num

npcGetSprite:	push	ix
		call	findNpc
		jr	c, loc_C381
		ld	c, (ix+3)
		jr	loc_C381

; C = npc B anim num

npcGetAnim:	push	ix
		call	findNpc
		jr	c, loc_C381
		ld	c, (ix+4)
		jr	loc_C381

; set anim C to npc B

npcSetAnim:	push	ix
		call	findNpc
		jr	c, loc_C381
		call	setAnim
		ld	(ix+0Eh), 1
		and	a
loc_C381:	pop	ix
		ret

; check place in front of NPC B & get npc/item/tile

npcCheckFront:	push	ix
		call	findNpc
		jr	c, loc_C381
		ld	a, (ix+3)
		inc	a
		scf
		jr	z, loc_C381
		call	sub_C398
		pop	ix
		ret

sub_C398:	ld	a, (ix+3)
getInFront:	ld	b, (ix+1)	; in	A = direction (up/down/left/right), IX = npc.dsc
		ld	c, (ix+2)	; out	CY=1: no way there
		ld	d, b		;	CY=0, H=npc.id (FF:no), L=item.id (FF:no); A=tile.nr
		ld	e, c
		and	a
		jr	z, frontUp
		dec	a
		jr	z, frontDown
		dec	a
		jr	z, frontLeft
		inc	e
		ld	a, e
		and	7
		jr	nz, loc_C3F3
		ld	h, 0FFh
		ld	a, 9
		call	ovEngineFunc
		ld	a, c
		and	38h
		jr	loc_C3F2
frontLeft:	ld	a, e
		dec	e
		and	7
		jr	nz, loc_C3F3
		ld	h, 0FEh
		ld	a, 9
		call	ovEngineFunc
		ld	a, c
		or	7
		jr	loc_C3F2
frontDown:	ld	a, e
		sub	8
		jr	nc, loc_C3F2
		ld	h, 0FCh
		ld	a, 9
		call	ovEngineFunc
		ld	a, c
		or	38h
		jr	loc_C3F2
frontUp:	ld	a, e
		add	a, 8
		cp	40h
		jr	c, loc_C3F2
		ld	h, 0FDh
		ld	a, 9
		call	ovEngineFunc
		ld	a, c
		and	7
loc_C3F2:	ld	e, a
loc_C3F3:	ld	a, d
		cp	0FFh
		scf
		ret	z
		push	bc
		push	de
		ld	b, d
		ld	c, e
		ld	a, 7
		call	ovEngineFunc
		ld	a, d
		pop	de
		pop	bc
		inc	a
		jr	z, loc_C410
		inc	a
		jr	z, loc_C454
		sub	2
		ld	hl, 0FFFFh
		ret
loc_C410:	push	ix
		ld	ix, npcTab
loc_C416:	ld	a, (ix+0)
		rla
		jp	c, fatalErr
		ld	a, (ix+3)
		cp	0FFh
		jr	z, loc_C43F
		ld	a, d
		cp	(ix+1)
		jr	nz, loc_C430
		ld	a, e
		cp	(ix+2)
		jr	z, loc_C448
loc_C430:	ld	a, d
		cp	(ix+10h)
		jr	nz, loc_C43F
		ld	a, e
		cp	(ix+11h)
		ld	a, (ix+12h)
		jr	z, loc_C44B
loc_C43F:	push	de
		ld	de, 20h
		add	ix, de
		pop	de
		jr	loc_C416
loc_C448:	ld	a, (ix+0Fh)
loc_C44B:	ld	h, (ix+0)
		ld	l, 0FFh
		pop	ix
		and	a
		ret
loc_C454:	push	ix
		ld	ix, itemsTab
loc_C45A:	ld	a, (ix+0)
		rla
		call	c, fatalErr
		ld	a, (ix+1)
		cp	d
		jr	nz, loc_C46D
		ld	a, (ix+2)
		cp	e
		jr	z, loc_C477
loc_C46D:	inc	ix
		inc	ix
		inc	ix
		inc	ix
		jr	loc_C45A
loc_C477:	ld	h, 0FFh
		ld	l, (ix+0)
		ld	a, (ix+3)
		pop	ix
		and	a
		ret
		

; FD,n	set animation n

aniFD:		ld	c, (hl)
setAnim:	ld	a, c		; set animation C to current NPC
		inc	a
		jp	z, aniFF
		ld	l, (ix+0Ch)
		ld	h, (ix+0Dh)
		ld	b, 0
		add	hl, bc
		add	hl, bc
		ld	a, (hl)
		inc	hl
		ld	h, (hl)
		ld	l, a
		ld	(ix+15h), l
		ld	(ix+16h), h
		ld	(ix+4),	c
		ld	(ix+0Eh), 1		; F8: set loop here
aniF8:		ld	(ix+17h), l
		ld	(ix+18h), h
		ret
		
aniF7:		ld	a, (ix+1)
		ld	(ix+10h), a
		ld	a, (ix+2)
		ld	(ix+11h), a
		ld	a, (ix+0Fh)
		ld	(ix+12h), a
		ret

; FE	go to loop adr (start of animation | F8)

aniFE:		ld	l, (ix+17h)
		ld	h, (ix+18h)
		ret
		
aniF3:		ld	a, (curMapNr)
		cp	(ix+13h)
		ret	z
		set	6, (ix+1Dh)
		jp	aniOff

; F2, r, e	if (rnd > r) then jr +e

aniF2:		push	hl
rndAdr:		ld	hl, 0FFFFh
		inc	hl
		ld	(rndAdr+1), hl
		ld	a, r
		xor	(hl)
		pop	hl
		cp	(hl)
		inc	hl
		inc	hl
		ret	c
		dec	hl
		ld	e, (hl)
		ld	d, 0
		inc	hl
		add	hl, de
		ret
		
; F1, id, snr, anr	set NPC id sprite snr & animation anr

aniF1:		push	ix
		ld	b, (hl)
		inc	hl
		call	findNpc
		call	c, fatalErr
		ld	c, (hl)
		inc	hl
		push	hl
		call	npcSetSprite
		pop	hl
		ld	c, (hl)
		inc	hl
		push	hl
		call	setAnim
		pop	hl
		pop	ix
		ret

; set sprite C to NPC B

setNpcSpr:	push	ix
		call	findNpc
		jr	c, loc_C514
		call	npcSetSprite
		ld	(ix+0Eh), 1
		and	a
loc_C514:	pop	ix
		ret

; find NPC B
; CY=1	not found
; CY=0	IX = NPC dsc
findNpc:	ld	ix, npcTab
		ld	de, 20h
loc_C51E:	ld	a, (ix+0)
		inc	a
		scf
		ret	z
		dec	a
		cp	b
		ret	z
		add	ix, de
		jr	loc_C51E

; set sprite C to current NPC (dsc:IX)
		
npcSetSprite:	ld	a, (curMapNr)
		cp	(ix+1)
		jr	z, loc_C53E
		ld	(ix+3),	c
		call	extCopySprDsc
		res	7, (ix+1Dh)
		ret
loc_C53E:	push	bc
		call	fArrOff
		pop	bc
		ld	a, c
		inc	a
		jr	nz, loc_C554
		ld	(ix+3),	c
		bit	7, (ix+1Dh)
		call	nz, restBG
		jp	loc_C5C6
loc_C554:	ld	a, (ix+3)
		inc	a
		jr	z, loc_C574
		call	npcCompareSpr
		jr	nz, loc_C56B
		ld	(ix+3),	c
		call	extCopySprDsc
		set	7, (ix+1Dh)
		jr	loc_C57D
loc_C56B:	push	bc
		bit	7, (ix+1Dh)
		call	nz, restBG
		pop	bc
loc_C574:	ld	(ix+3),	c
		call	extCopySprDsc
		call	saveBG
loc_C57D:	ld	a, 37h
		bit	0, (ix+1Dh)
		jr	z, loc_C587
		ld	a, 0A7h
loc_C587:	ld	(loc_C5A4), a
		ld	e, (ix+1Eh)
		ld	d, (ix+1Fh)
		ld	l, (ix+1Bh)
		ld	h, (ix+1Ch)
		exx
		call	aniGetBufAdr
		ex	de, hl
		exx
		ld	b, (ix+1Ah)
loc_C59F:	ld	c, (ix+19h)
		push	de
loc_C5A3:	ld	a, (hl)
loc_C5A4:	scf
		jr	c, loc_C5AD
		exx
		and	(hl)
		inc	hl
		exx
		inc	hl
		or	(hl)
loc_C5AD:	ld	(de), a
		inc	hl
		inc	e
		dec	c
		jr	nz, loc_C5A3
		pop	de
		inc	d
		ld	a, d
		and	7
		jr	nz, loc_C59F
		ld	a, e
		add	a, 20h
		ld	e, a
		jr	c, loc_C5C4
		ld	a, d
		sub	8
		ld	d, a
loc_C5C4:	djnz	loc_C59F
loc_C5C6:	push	hl
		ld	a, (arrDState)
		cp	0C9h
		call	nz, fArrOn
		pop	hl
		ret
		
; check if sprite C is on the same place & have asme size as current
; Z=1 : same
		
npcCompareSpr:	ld	b, 0
		ld	l, (ix+0Ah)
		ld	h, (ix+0Bh)
		add	hl, bc
		add	hl, bc
		ld	a, (hl)
		inc	hl
		ld	h, (hl)
		ld	l, a
		ld	a, (ix+19h)
		cp	(hl)
		ret	nz
		inc	hl
		ld	a, (ix+1Ah)
		cp	(hl)
		ret	nz
		push	bc
		call	npcScreenAdr
		pop	bc
		ld	a, (ix+1Eh)
		cp	l
		ret	nz
		ld	a, (ix+1Fh)
		cp	h
		ret

; copy sprite C data (dx,dy,<adr>) to NPC dsc

extCopySprDsc:	ld	b, 0
		ld	e, xl
		ld	d, xh
		ld	hl, 0x19
		add	hl, de
		ex	de, hl
		ld	l, (ix+0Ah)
		ld	h, (ix+0Bh)
		add	hl, bc
		add	hl, bc
		ld	a, (hl)
		inc	hl
		ld	h, (hl)
		ld	l, a
		ldi
		ldi
		ldi
		ldi
		ldi
		ret
		
; HL = scr.adr of current NPC sprite
		
npcScreenAdr:	ld	a, (ix+2)
		and	7
		add	a, a
		inc	a
		ld	b, a
		ld	a, (ix+2)
		rra
		rra
		and	1Eh
		inc	a
		ld	c, a
		ld	a, c
		rrca
		rrca
		rrca
		and	0E0h
		or	b
		ld	l, a
		ld	a, c
		and	18h
		or	40h
		ld	h, a
		ret

; calc NPC scr.adr & save BG to buffer
		
saveBG:		set	7, (ix+1Dh)
		call	npcScreenAdr
		bit	3, (ix+1Dh)
		jr	z, loc_C64A
		dec	l
		dec	l
loc_C64A:	bit	4, (ix+1Dh)
		jr	z, loc_C65A
		ld	a, l
		sub	40h
		ld	l, a
		jr	nc, loc_C65A
		ld	a, h
		sub	8
		ld	h, a
loc_C65A:	ld	(ix+1Eh), l
		ld	(ix+1Fh), h
		ld	a, 2		; ???
		set	7, (ix+1Dh)	; ???
		xor	a
		jr	loc_C675

; restore NPC background on screen
		
restBG:		ld	l, (ix+1Eh)
		ld	h, (ix+1Fh)
		res	7, (ix+1Dh)
		ld	a, 0EBh		; OPCODE: ex de,hl
loc_C675:	ld	(loc_C685), a
		ld	(loc_C68E), a
		call	aniGetBufAdr
		ld	b, (ix+1Ah)
		ld	c, 0FFh
loc_C683:	ld	a, l
		ex	af, af'
loc_C685:	nop
		ld	a, (ix+19h)
loc_C689:	ldi
		dec	a
		jr	nz, loc_C689
loc_C68E:	nop
		ex	af, af'
		ld	l, a
		inc	h
		ld	a, h
		and	7
		jr	nz, loc_C683
		ld	a, l
		add	a, 20h
		ld	l, a
		jr	c, loc_C6A1
		ld	a, h
		sub	8
		ld	h, a
loc_C6A1:	djnz	loc_C683
		ret

; DE = buffer (128 bytes) for current NPC (0xBF80 - 0x80 * id)

aniGetBufAdr:	push	hl
		ld	d, (ix+0)
		ld	e, 0
		srl	d
		rr	e
		ld	hl, 0xBF80
		and	a
		sbc	hl, de
		ex	de, hl
		pop	hl
		ret

; F4	restore old place tile

aniF4:		push	hl
		ld	b, (ix+10h)
		ld	c, (ix+11h)
		ld	d, (ix+12h)
loc_C6C1:	ld	a, 8
		call	ovEngineFunc
		pop	hl
		ret
		
; restore tile under NPC

restTile:	push	hl
		ld	b, (ix+1)
		ld	c, (ix+2)
		ld	d, (ix+0Fh)
		jr	loc_C6C1
		
; F6	update coord, store tile, set FF on map (place NPC on new coords)

aniF6:		push	hl
		ld	b, (ix+13h)
		ld	c, (ix+14h)
		ld	(ix+1),	b
		ld	(ix+2),	c
		ld	a, 7
		call	ovEngineFunc
		ld	(ix+0Fh), d
		ld	d, 0FFh
		jr	loc_C6C1
		
; get item C & remove it from map

addItem:	push	bc
		push	de
		call	putInBag
		pop	de
		pop	bc
		ret	c
		ld	hl, itemsTab
loc_C6F8:	ld	a, (hl)
		rla
		call	c, fatalErr
		inc	hl
		rra
		cp	c
		jr	z, loc_C707
		inc	hl
		inc	hl
		inc	hl
		jr	loc_C6F8
loc_C707:	push	bc
		ld	a, (hl)
		ld	b, a
		ld	(hl), 0C8h
		cp	d
		call	nz, fatalErr
		inc	hl
		ld	a, (hl)
		ld	c, a
		ld	(hl), 1
		cp	e
		call	nz, fatalErr
		inc	hl
		ld	d, (hl)
		ld	a, 8
		call	ovEngineFunc
		ld	a, 0Bh
		call	ovEngineFunc
		pop	bc
		ret
; ---------------------------------------------------------------------------
; put current item on map D crd E

dropItem:	call	extGetCurItem
		ld	a, c
		and	a
		scf
		ret	z
		ld	hl, itemsTab
		push	bc
loc_C732:	ld	a, (hl)
		rla
		call	c, fatalErr
		inc	hl
		rra
		cp	c
		jr	z, loc_C741
		inc	hl
		inc	hl
		inc	hl
		jr	loc_C732
loc_C741:	push	hl
		ld	c, e
		ld	b, d
		ld	a, 7
		call	ovEngineFunc
		pop	hl
		push	hl
		ld	(hl), b
		inc	hl
		ld	(hl), c
		inc	hl
		ld	(hl), d
		ld	d, 0FEh
		ld	a, 8
		call	ovEngineFunc
		pop	hl
		dec	hl
		ld	d, (hl)
		ld	a, 0Ah
		call	ovEngineFunc
		pop	bc
		jp	delFromBag

; Check if item C is in bag.
; Z = 0/1 = no/yes

extCheckItem:	ld	a, c
		cp	(ix+7)
		ret	z
		cp	(ix+8)
		ret	z
		cp	(ix+9)
		ret

; C = current item ID

extGetCurItem:	ld	a, (curItem)
		ld	c, (ix+7)
		and	a
		ret	z
		ld	c, (ix+8)
		dec	a
		ret	z
		ld	c, (ix+9)
		ret

; delete item C from bag

delFromBag:	ld	a, (ix+7)
		ld	(ix+7),	0
		cp	c
		jr	z, loc_C7D2
		ld	(ix+7),	a
		ld	a, (ix+8)
		ld	(ix+8),	0
		cp	c
		jr	z, loc_C7D2
		ld	(ix+8),	a
		ld	a, (ix+9)
		ld	(ix+9),	0
		cp	c
		jr	z, loc_C7D2
		ld	(ix+9),	a
		call	fatalErr
		ret

; place item C in bag.
;out	CY=1 : error

putInBag:	ld	a, (ix+7)
		ld	(ix+7),	c
		and	a
		jr	z, loc_C7D2
		ld	(ix+7),	a
		ld	a, (ix+8)
		ld	(ix+8),	c
		and	a
		jr	z, loc_C7D2
		ld	(ix+8),	a
		ld	a, (ix+9)
		ld	(ix+9),	c
		and	a
		jr	z, loc_C7D2
		ld	(ix+9),	a
		scf
		ret
loc_C7D2:	call	drawBag
		and	a
		ret
		
; redraw bag

drawBag:	ld	de, 59B6h
		exx
		ld	de, 48B6h
		ld	a, (ix+7)
		call	drawItem
		ld	de, 59B9h
		exx
		ld	de, 48B9h
		ld	a, (ix+8)
		call	drawItem
		ld	de, 59BCh
		exx
		ld	de, 48BCh
		ld	a, (ix+9)
drawItem:	ld	l, a
		ld	h, 0
		add	hl, hl
		add	hl, hl
		ld	c, l
		ld	b, h
		add	hl, hl
		add	hl, hl
		add	hl, hl
		add	hl, bc
		ld	bc, itemsData
		add	hl, bc
		ld	bc, 2FFh
loc_C80D:	ldi
		ldi
		dec	e
		dec	e
		inc	d
		ld	a, d
		and	7
		jr	nz, loc_C80D
		ld	a, e
		add	a, 20h
		ld	e, a
		ld	d, 48h
		djnz	loc_C80D
		push	hl
		exx
		pop	hl
		ldi
		ldi
		ld	a, e
		add	a, 1Eh
		ld	e, a
		ldi
		ldi
		ret
		
waitNpc:	push	ix
		call	findNpc
		jr	c, loc_C875
loc_C838:	ld	a, (ix+4)
		inc	a
		jr	z, loc_C875
		bit	6, (ix+1Dh)
		jr	z, loc_C838
		bit	5, (ix+1Dh)
		jr	z, loc_C860
		call	Jalousie
		ld	a, (ix+3)
		ld	(byte_C87B), a
		ld	hl, byte_C878
		ld	(ix+15h), l
		ld	(ix+16h), h
		ld	(ix+4),	0FEh
loc_C860:	ld	c, (ix+13h)
		ld	a, 6
		call	ovEngineFunc
		res	5, (ix+1Dh)
		res	6, (ix+1Dh)
		call	aniOn
		jr	loc_C838
loc_C875:	pop	ix
		ret

byte_C878:	db 0F4h, 0F6h, 1
byte_C87B:	db 0, 0FFh

; ---------------------------------------------------------------------------
; jalousie effect on map

Jalousie:	ld	hl, 4021h
		ld	b, 10h
loc_C882:	ld	e, l
		ld	c, 10h
loc_C885:	ld	(hl), 0
		and	d
		ld	(hl), a
		inc	l
		dec	c
		jr	nz, loc_C885
		halt
		ld	l, e
		inc	h
		inc	h
		ld	a, h
		and	7
		jr	nz, loc_C882
		ld	a, l
		add	a, 20h
		ld	l, a
		jr	c, loc_C8A0
		ld	a, h
		sub	8
		ld	h, a
loc_C8A0:	djnz	loc_C882
		ret
		
; redraw all npc & items

drawAll:	push	ix
		ld	ix, npcTab	; 1. npc
loc_C8A9:	ld	a, (ix+0)
		rla
		jr	c, loc_C8DB
		ld	a, (ix+3)
		inc	a
		jr	z, loc_C8D4
		ld	b, (ix+1)
		ld	c, (ix+2)
		ld	a, 7
		call	ovEngineFunc
		ld	(ix+0Fh), d
		ld	d, 0FFh
		ld	a, 8
		call	ovEngineFunc
		ld	c, (ix+3)
		ld	(ix+3),	0FFh
		call	npcSetSprite
loc_C8D4:	ld	de, 20h
		add	ix, de
		jr	loc_C8A9
loc_C8DB:	ld	ix, itemsTab	; 2. items
loc_C8DF:	bit	7, (ix+0)
		jr	nz, loc_C913
		ld	b, (ix+1)
		ld	c, (ix+2)
		ld	a, 7
		call	ovEngineFunc
		ld	(ix+3),	d
		ld	d, 0FEh
		ld	a, 8
		call	ovEngineFunc
		ld	a, (curMapNr)
		cp	b
		ld	d, (ix+0)
		ld	c, (ix+2)
		ld	a, 0Ah
		call	z, ovEngineFunc
		inc	ix
		inc	ix
		inc	ix
		inc	ix
		jr	loc_C8DF
loc_C913:	pop	ix
		ret
		
; remove all npc & items from map, restore BG
		
removeAll:	push	ix
		ld	ix, npcTab	; 1. npc
loc_C91C:	ld	a, (ix+0)
		rla
		jr	c, loc_C948
		ld	a, (ix+3)
		inc	a
		jr	z, loc_C93D
		ld	b, (ix+1)
		ld	c, (ix+2)
		ld	d, (ix+0Fh)
		ld	a, 8
		call	ovEngineFunc
		bit	7, (ix+1Dh)
		call	nz, restBG
loc_C93D:	res	7, (ix+1Dh)
		ld	de, 20h
		add	ix, de
		jr	loc_C91C	
loc_C948:	ld	ix, itemsTab	; 2. items
loc_C94C:	bit	7, (ix+0)
		jr	nz, loc_C913
		ld	b, (ix+1)
		ld	c, (ix+2)
		ld	d, (ix+3)
		ld	a, 8
		call	ovEngineFunc
		ld	a, (curMapNr)
		cp	b
		ld	d, (ix+3)
		ld	c, (ix+2)
		ld	a, 0Bh
		call	z, ovEngineFunc
		inc	ix
		inc	ix
		inc	ix
		inc	ix
		jr	loc_C94C
		
; ---------------------------------------------------------------------------
; npc init : id, map, coord, spr, ani

npcInitTab:	db 0, 0, 4, 0, 0FFh	; RAM:C0B2o
		db 1, 0, 0Ch, 0, 0FFh
		db 3, 0Ah, 1Bh,	1, 0FFh
		db 4, 9, 33h, 0, 0
		db 5, 9, 2Bh, 0, 0FFh
		db 6, 0Eh, 24h,	0, 1
		db 7, 0Eh, 2Ch,	0, 0FFh
		db 8, 12h, 0Ch,	0, 0
		db 9, 14h, 0Fh,	0, 0FFh
		db 0Ah,	17h, 13h, 0, 0
		db 0Bh,	1Bh, 10h, 0, 0
		db 0Ch,	1Ah, 36h, 0, 0
		db 0Dh,	26h, 25h, 0, 0
		db 0Eh,	27h, 24h, 0, 1
		db 0Fh,	0C8h, 3Eh, 0, 0FFh
		db 10h,	3Bh, 23h, 0, 0
		db 11h,	3Bh, 22h, 2, 1
		db 12h,	3Bh, 25h, 4, 0FFh
		db 13h,	0C8h, 0Ch, 0, 0FFh
		db 14h,	44h, 23h, 0, 0
		db 15h,	44h, 24h, 0, 0
		db 16h,	42h, 22h, 0, 0
		db 17h,	45h, 19h, 0, 0FFh
		db 18h,	50h, 0Bh, 1, 0FFh
		db 19h,	4Bh, 13h, 0, 0FFh
		db 1Ah,	4Bh, 15h, 1, 0FFh
		db 1Ch,	57h, 1Ch, 0, 0
		db 1Dh,	5Ah, 11h, 0, 0
		db 1Eh,	5Ah, 13h, 0, 0
		db 1Fh,	5Ah, 1Bh, 0, 0
		db 20h,	5Ah, 35h, 0, 0FFh
		db 1Bh,	54h, 0Ch, 0, 0FFh
		db 21h,	0C9h, 2, 0, 0FFh
		db 22h,	0C8h, 8, 0, 0FFh
		db 23h,	0C8h, 9, 0, 0FFh
		db 24h,	0C8h, 0Ah, 0, 0FFh
		db 25h,	0C8h, 0Bh, 0, 0FFh
		db 26h,	64h, 3,	0, 0FFh
		db 27h,	64h, 9,	0, 0FFh
		db 28h,	64h, 0Dh, 0, 0FFh
		db 29h,	64h, 21h, 0, 0FFh
		db 2Ah,	64h, 25h, 0, 0FFh
		db 2Bh,	64h, 2Bh, 0, 0FFh
		db 2Ch,	65h, 0,	0, 0FFh
		db 0FFh
		
; items init: id, map, coord

itemInitTab:	db 2, 7, 11h		; RAM:loc_C104o
		db 3, 3, 29h
		db 5, 16h, 36h
		db 0Bh,	28h, 1Dh
		db 0Eh,	2Ah, 10h
		db 0Fh,	2Ch, 16h
		db 14h,	3Ch, 24h
		db 1Ah,	56h, 19h
		db 0FFh
		
; npc list : id, sprTabAdr, aniTabAdr (other fields is inited)

npcTab:		NPC 0, npc00sprTab, npc00aniTab
		NPC 1, npc01sprTab, npc01aniTab
		NPC 3, npc03sprTab, npc03aniTab
		NPC 4, npc04sprTab, npc04aniTab
		NPC 5, npc05sprTab, 0
		NPC 6, npc06sprTab, npc06aniTab
		NPC 16h, npc1DsprTab, npc1DaniTab
		NPC 7, npc07sprTab, npc07aniTab
		NPC 8, npc08sprTab, npc08aniTab
		NPC 9, npc09sprTab, npc09aniTab
		NPC 0Ah, npc0AsprTab, npc0AaniTab
		NPC 0Bh, npc0BsprTab, npc0BaniTab
		NPC 0Ch, npc0CsprTab, npc0CaniTab
		NPC 0Dh, npc0DsprTab, npc0DaniTab
		NPC 0Eh, npc0DsprTab, npc0DaniTab
		NPC 0Fh, npc0FsprTab, npc0FaniTab
		NPC 10h, npc10sprTab, npc10aniTab
		NPC 11h, npc10sprTab, npc10aniTab
		NPC 12h, npc10sprTab, npc10aniTab
		NPC 13h, npc13sprTab, npc13aniTab
		NPC 14h, npc14sprTab, npc14aniTab
		NPC 15h, npc15sprTab, npc15aniTab
		NPC 17h, npc17sprTab, 0
		NPC 18h, npc18sprTab, 0
		NPC 19h, npc19sprTab, 0
		NPC 1Ah, npc19sprTab, 0
		NPC 1Ch, npc1CsprTab, npc1CaniTab
		NPC 1Dh, npc1DsprTab, npc1DaniTab
		NPC 1Eh, npc1DsprTab, npc1DaniTab
		NPC 1Bh, npc1BsprTab, npc1BaniTab
		NPC 21h, npc21sprTab, npc21aniTab
		NPC 1Fh, npc1FsprTab, npc1FaniTab
		NPC 20h, npc20sprTab, npc20aniTab
		NPC 22h, npc22sprTab, npc22aniTab
		NPC 23h, npc23sprTab, npc22aniTab
		NPC 24h, npc24sprTab, npc22aniTab
		NPC 25h, npc25sprTab, npc22aniTab
		NPC 26h, npc26sprTab, npc26aniTab
		NPC 27h, npc26sprTab, npc26aniTab
		NPC 28h, npc26sprTab, npc26aniTab
		NPC 29h, npc26sprTab, npc26aniTab
		NPC 2Ah, npc26sprTab, npc26aniTab
		NPC 2Bh, npc26sprTab, npc26aniTab
		NPC 2Ch, npc2CsprTab, npc2CaniTab
		db 0FFh
		
; items list : id, map, coord, tile_under

itemsTab:	db 1, 0C8h, 1, 0
		db 2, 0C8h, 2, 0
		db 3, 0C8h, 3, 0
		db 4, 0C8h, 4, 0
		db 5, 0C8h, 5, 0
		db 6, 0C8h, 6, 0
		db 7, 0C8h, 7, 0
		db 8, 0C8h, 8, 0
		db 9, 0C8h, 9, 0
		db 0Ah,	0C8h, 0Ah, 0
		db 0Bh,	0C8h, 0Bh, 0
		db 0Ch,	0C8h, 0Ch, 0
		db 0Dh,	0C8h, 0Dh, 0
		db 0Eh,	0C8h, 0Eh, 0
		db 0Fh,	0C8h, 0Fh, 0
		db 10h,	0C8h, 10h, 0
		db 11h,	0C8h, 11h, 0
		db 12h,	0C8h, 12h, 0
		db 13h,	0C8h, 13h, 0
		db 14h,	0C8h, 14h, 0
		db 15h,	0C8h, 15h, 0
		db 16h,	0C8h, 16h, 0
		db 17h,	0C8h, 17h, 0
		db 18h,	0C8h, 18h, 0
		db 19h,	0C8h, 19h, 0
		db 1Ah,	0C8h, 1Ah, 0
		db 1Bh,	0C8h, 1Bh, 0
		db 1Ch,	0C8h, 1Ch, 0
		db 1Dh,	0C8h, 1Dh, 0
		db 1Eh,	0C8h, 1Eh, 0
		db 0FFh
		
; npc 00

npc00sprTab:	dw stru_D0D7
		dw stru_D0DC
		dw stru_D0E1
		dw stru_D0E6
		dw stru_D0EB
		dw stru_D0F0
		dw stru_D0F5
		dw stru_D0FA
		dw stru_D0FF
		dw stru_D104
		dw stru_D109
		dw stru_D10E
		dw stru_D113
		dw stru_D118
		dw stru_D11D
		dw stru_D122
		dw stru_D127
		dw stru_D12C
		dw stru_D131
		dw stru_D136
		dw stru_D13B
		dw stru_D140
		dw stru_D145
		dw stru_D14A
		dw stru_D14F
		dw stru_D154
		dw stru_D159
		dw stru_D15E
		dw stru_D163
		dw stru_D168
		dw stru_D16D
		dw stru_D172
		dw stru_D177
		dw stru_D17C
		dw stru_D181
		dw stru_D186
		dw stru_D18B
		dw stru_D190
		dw stru_D195
		dw stru_D19A
		dw stru_D19F
		dw stru_D1A4
		dw stru_D1A9
		dw stru_D1AE
		dw stru_D1B3
		dw stru_D1B8
		dw emptySpr
		
npc00aniTab:	dw byte_D1BD
		dw byte_D1DF
		dw byte_D201
		dw byte_D223
		dw byte_D245
		dw byte_D24A
		dw byte_D263
		dw byte_D285
		
stru_D0D7:	SPRITE 2, 2, npc00sprData+120h, 1
stru_D0DC:	SPRITE 2, 2, npc00sprData+2A0h, 1
stru_D0E1:	SPRITE 2, 2, npc00sprData, 1
stru_D0E6:	SPRITE 2, 2, npc00sprData+40h,	1
stru_D0EB:	SPRITE 2, 4, npc00sprData+80h,	11h
stru_D0F0:	SPRITE 2, 4, npc00sprData+100h, 11h
stru_D0F5:	SPRITE 2, 4, npc00sprData+180h, 11h
stru_D0FA:	SPRITE 2, 4, npc00sprData+200h, 1
stru_D0FF:	SPRITE 2, 4, npc00sprData+280h, 1
stru_D104:	SPRITE 2, 4, npc00sprData+300h, 1
stru_D109:	SPRITE 4, 2, npc00sprData+380h, 1
stru_D10E:	SPRITE 4, 2, npc00sprData+400h, 1
stru_D113:	SPRITE 4, 2, npc00sprData+480h, 1
stru_D118:	SPRITE 4, 2, npc00sprData+500h, 9
stru_D11D:	SPRITE 4, 2, npc00sprData+580h, 9
stru_D122:	SPRITE 4, 2, npc00sprData+600h, 9
stru_D127:	SPRITE 2, 2, npc00sprData+80h,	1
stru_D12C:	SPRITE 2, 2, npc00sprData+100h, 1
stru_D131:	SPRITE 2, 2, npc00sprData+180h, 1
stru_D136:	SPRITE 2, 2, npc00sprData+240h, 1
stru_D13B:	SPRITE 2, 2, npc00sprData+2C0h, 1
stru_D140:	SPRITE 2, 2, npc00sprData+340h, 1
stru_D145:	SPRITE 2, 2, npc00sprData+680h, 1
stru_D14A:	SPRITE 2, 2, npc00sprData+6C0h, 1
stru_D14F:	SPRITE 2, 2, npc00sprData+700h, 1
stru_D154:	SPRITE 2, 2, npc00sprData+740h, 1
stru_D159:	SPRITE 2, 2, npc00sprData+780h, 1
stru_D15E:	SPRITE 2, 2, npc00sprData+700h, 1
stru_D163:	SPRITE 2, 2, npc00sprData+0C0h, 1
stru_D168:	SPRITE 2, 2, npc00sprData+140h, 1
stru_D16D:	SPRITE 2, 2, npc00sprData+1C0h, 1
stru_D172:	SPRITE 2, 2, npc00sprData+200h, 1
stru_D177:	SPRITE 2, 2, npc00sprData+280h, 1
stru_D17C:	SPRITE 2, 2, npc00sprData+300h, 1
stru_D181:	SPRITE 2, 2, npc00sprData+7C0h, 1
stru_D186:	SPRITE 2, 2, npc00sprData+800h, 1
stru_D18B:	SPRITE 2, 2, npc00sprData+840h, 1
stru_D190:	SPRITE 2, 2, npc00sprData+880h, 1
stru_D195:	SPRITE 2, 2, npc00sprData+8C0h, 1
stru_D19A:	SPRITE 2, 2, npc00sprData+900h, 1
stru_D19F:	SPRITE 2, 1, npc00sprData+940h, 0
stru_D1A4:	SPRITE 2, 1, npc00sprData+950h, 0
stru_D1A9:	SPRITE 2, 1, npc00sprData+960h, 0
stru_D1AE:	SPRITE 2, 2, npc00sprData+970h, 1
stru_D1B3:	SPRITE 2, 2, npc00sprData+9B0h, 1
stru_D1B8:	SPRITE 2, 2, npc00sprData+9F0h, 1

byte_D1BD:	db 0F7h, 0F9h, 0Bh, 0F6h, 5, 4,	5, 5, 5, 6, 0F4h, 1, 0,	0FFh, 5, 10h
		db 5, 11h, 5, 12h, 1, 2Eh, 0F6h, 0F4h, 0F3h, 5,	1Ch, 5,	1Dh, 5,	1Eh, 1
		db 0, 0FFh
byte_D1DF:	db 0F7h, 0FAh, 0Bh, 0F6h, 5, 7,	5, 8, 5, 9, 0F4h, 1, 1,	0FFh, 5, 13h
		db 5, 14h, 5, 15h, 1, 2Eh, 0F6h, 0F4h, 0F3h, 5,	1Fh, 5,	20h, 5,	21h, 1
		db 1, 0FFh
byte_D201:	db 0F7h, 0FBh, 0Bh, 0F6h, 5, 0Ah, 5, 0Bh, 5, 0Ch, 0F4h,	1, 2, 0FFh, 5, 16h
		db 5, 17h, 5, 18h, 1, 2Eh, 0F6h, 0F4h, 0F3h, 5,	22h, 5,	23h, 5,	24h, 1
		db 2, 0FFh
byte_D223:	db 0F7h, 0FCh, 0Bh, 0F6h, 5, 0Dh, 5, 0Eh, 5, 0Fh, 0F4h,	1, 3, 0FFh, 5, 19h
		db 5, 1Ah, 5, 1Bh, 1, 2Eh, 0F6h, 0F4h, 0F3h, 5,	25h, 5,	26h, 5,	27h, 1
		db 3, 0FFh
byte_D245:	db 0F7h, 0F3h, 0F6h, 0F4h, 0FFh
byte_D24A:	db 0F7h, 19h, 28h, 5, 2Ah, 19h,	29h, 5,	2Ah, 19h, 28h, 0FAh, 0,	0F6h, 0F4h, 0F3h
		db 5, 1Fh, 5, 20h, 5, 21h, 1, 1, 0FFh
byte_D263:	db 0F7h, 0F8h, 5, 0, 5,	2Bh, 5,	0, 5, 2Bh, 5, 2Ch, 5, 2Bh, 5, 2Ch
		db 5, 2Bh, 5, 2Ch, 5, 2Dh, 5, 2Ch, 5, 2Dh, 5, 2Eh, 5, 2Dh, 5, 2Eh
		db 0F6h, 0FFh
byte_D285:	db 0F7h, 0F8h, 5, 2Eh, 5, 2Dh, 5, 2Eh, 5, 2Dh, 5, 2Ch, 5, 2Dh, 5, 2Ch
		db 5, 2Dh, 5, 2Ch, 5, 2Bh, 5, 2Ch, 5, 2Bh, 5, 0, 5, 2Bh, 5, 0
		db 0F4h, 0FFh
		
npc00sprData	incbin "npcspr/npc00spr.bin"

; npc 01

npc01sprTab:	dw stru_DD03
		dw stru_DD08
		dw stru_DD0D
		dw stru_DD12
		dw stru_DD17
		dw stru_DD1C
		dw stru_DD21
		dw emptySpr
		dw stru_DD26
		dw stru_DD2B
		dw stru_DD30
		dw stru_DD35
		dw stru_DD3A
		dw stru_DD3F
		
npc01aniTab:	dw byte_DD44
		dw byte_DD55
		dw byte_DD6E
		dw byte_DD77
		dw byte_DD7D
		dw byte_DD83
		dw byte_DD93
		dw byte_DDA3
		
stru_DD03:	SPRITE 2, 2, npc01sprData, 1
stru_DD08:	SPRITE 2, 2, npc01sprData+40h, 1
stru_DD0D:	SPRITE 2, 2, npc01sprData+80h, 1
stru_DD12:	SPRITE 2, 2, npc01sprData+0C0h, 1
stru_DD17:	SPRITE 2, 2, npc01sprData+100h, 1
stru_DD1C:	SPRITE 2, 2, npc01sprData+140h, 1
stru_DD21:	SPRITE 2, 2, npc01sprData+180h, 1
stru_DD26:	SPRITE 2, 2, npc01sprData+1C0h, 1
stru_DD2B:	SPRITE 2, 2, npc01sprData+200h, 1
stru_DD30:	SPRITE 2, 2, npc01sprData+240h, 1
stru_DD35:	SPRITE 2, 2, npc01sprData+280h, 1
stru_DD3A:	SPRITE 2, 2, npc01sprData+2C0h, 1
stru_DD3F:	SPRITE 2, 2, npc01sprData+300h, 1

byte_DD44:	db 5, 0, 5, 1, 5, 0, 5,	1, 0Ah,	2, 0Ah,	3, 0Ah,	4, 0Ah,	6
		db 0FFh
byte_DD55:	db 0Ah,	6, 0Ah,	4, 0Ah,	3, 0Ah,	2, 0Ah,	1, 5, 0, 5, 1, 5, 0
		db 5, 1, 1, 7, 0F5h, 0Ah, 0Bh, 5, 0FFh
byte_DD6E:	db 0F7h, 0F8h, 1, 7, 0F5h, 64h,	1Bh, 5,	0FFh
byte_DD77:	db 0F7h, 28h, 8, 1, 5, 0FFh
byte_DD7D:	db 0F7h, 28h, 9, 1, 5, 0FFh
byte_DD83:	db 0F7h, 5, 0Bh, 5, 0Ah, 5, 0Bh, 5, 0Ah, 5, 0Bh, 5, 0Ah, 1, 5, 0FFh
byte_DD93:	db 0F7h, 5, 0Dh, 5, 0Ah, 5, 0Dh, 5, 0Ah, 5, 0Dh, 5, 0Ah, 1, 5, 0FFh
byte_DDA3:	db 0F7h, 5, 0Ch, 5, 0Ah, 5, 0Ch, 5, 0Ah, 5, 0Ch, 5, 0Ah, 1, 5, 0FFh

npc01sprData:	incbin "npcspr/npc01spr.bin"

; npc 03

npc03sprTab:	dw stru_E107
		dw stru_E10C
		dw stru_E111
		dw stru_E116
		dw stru_E11B
		dw stru_E120
		
npc03aniTab:	dw byte_E125
		dw byte_E13A
		dw byte_E14F
		dw byte_E164
		
stru_E107:	SPRITE 2, 2, npc03sprData, 1
stru_E10C:	SPRITE 2, 2, npc03sprData+40h, 1
stru_E111:	SPRITE 2, 2, npc03sprData+80h, 1
stru_E116:	SPRITE 2, 2, npc03sprData+0C0h, 1
stru_E11B:	SPRITE 2, 2, npc03sprData+100h, 1
stru_E120:	SPRITE 2, 2, npc03sprData+140h, 1

byte_E125:	db 3, 0, 3, 1, 3, 0, 3,	2, 3, 0, 3, 2, 3, 0, 3,	2
		db 3, 0, 3, 1, 0FFh
byte_E13A:	db 3, 0, 3, 1, 3, 0, 3,	3, 3, 0, 3, 3, 3, 0, 3,	3
		db 3, 0, 3, 1, 0FFh
byte_E14F:	db 3, 0, 3, 1, 3, 0, 3,	4, 3, 0, 3, 4, 3, 0, 3,	4
		db 3, 0, 3, 1, 0FFh
byte_E164:	db 3, 0, 3, 2, 3, 0, 3,	3, 3, 0, 3, 4, 3, 0, 3,	2
		db 3, 0, 3, 3, 3, 0, 3,	4, 3, 0, 3, 2, 3, 0, 3,	3
		db 3, 0, 3, 4, 3, 0, 3,	2, 3, 0, 3, 3, 3, 0, 3,	4
		db 3, 0, 3, 2, 3, 0, 3,	3, 3, 0, 3, 4, 3, 0, 3,	2
		db 3, 0, 3, 3, 3, 0, 3,	4, 3, 0, 3, 2, 3, 0, 3,	3
		db 3, 0, 3, 4, 3, 0, 3,	2, 3, 0, 3, 3, 3, 0, 3,	4
		db 3, 0, 3, 2, 3, 0, 3,	3, 3, 0, 3, 4, 3, 0, 3,	2
		db 3, 0, 3, 3, 3, 0, 3,	4, 0F8h, 3, 1, 0Ch, 0, 3, 1, 16h
		db 1, 0FEh
		
npc03sprData:	incbin "npcspr/npc03spr.bin"
		
; npc 04

npc04sprTab:	dw stru_E36E
		dw stru_E373
		dw stru_E378
		
npc04aniTab:	dw byte_E37D

stru_E36E:	SPRITE 2, 2, npc04sprData, 1
stru_E373:	SPRITE 2, 2, npc04sprData+40h, 1
stru_E378:	SPRITE 2, 2, npc04sprData+80h, 1

byte_E37D:	db 5, 0, 5, 1, 5, 2, 0FEh

npc04sprData:	incbin "npcspr/npc04spr.bin"

; npc 05

npc05sprTab:	dw stru_E446

stru_E446:	SPRITE 2, 2, npc05sprData, 1

npc05sprData:	incbin "npcspr/npc05spr.bin"

; npc 06,07

npc06sprTab:	dw stru_E49D
		dw stru_E4A2
		dw stru_E4A7
		dw stru_E4AC
		dw stru_E4B1
		dw stru_E4B6
		dw stru_E4BB
		
npc06aniTab:	dw byte_E4C0
		dw byte_E4D2
		
stru_E49D:	SPRITE 2, 2, npc06sprData, 1 
stru_E4A2:	SPRITE 2, 2, npc06sprData+40h, 1
stru_E4A7:	SPRITE 2, 2, npc06sprData+80h, 1
stru_E4AC:	SPRITE 2, 4, npc06sprData+0C0h, 1
stru_E4B1:	SPRITE 2, 6, npc06sprData+140h, 1
stru_E4B6:	SPRITE 2, 6, npc06sprData+200h, 1
stru_E4BB:	SPRITE 2, 6, npc06sprData+2C0h, 1

byte_E4C0:	db 0F7h, 0FAh, 0, 0F6h,	0Ah, 4,	0Ah, 5,	0Ah, 6,	0F4h, 1, 3, 0F1h, 7, 1
		db 0, 0FFh
byte_E4D2:	db 0F8h, 1, 0, 0F2h, 0E6h, 1, 0FEh, 0F2h, 80h, 3, 14h, 1, 0FEh,	14h, 2,	0FEh

npc07sprTab:	dw stru_E4E8
		dw stru_E4ED
		
npc07aniTab:	dw byte_E4F2

stru_E4E8:	SPRITE 2, 2, npc06sprData+380h, 1
stru_E4ED:	SPRITE 2, 2, emptySprData, 1

byte_E4F2:	db 0F7h, 0FAh, 0, 0F6h,	0F4h, 1, 1, 0FFh, 0FFh

npc06sprData:	incbin "npcspr/npc06spr.bin"

; npc 08

npc08sprTab:	dw stru_E8C4
		dw stru_E8C9
		dw stru_E8CE
		
npc08aniTab:	dw byte_E8D3
		dw byte_E8DD
		
stru_E8C4:	SPRITE 2, 2, npc08sprData, 1
stru_E8C9:	SPRITE 2, 2, npc08sprData+40h, 1
stru_E8CE:	SPRITE 2, 2, npc08sprData+80h, 1

byte_E8D3:	db 0F8h, 1, 0, 0F2h, 0F0h, 1, 0FEh, 19h, 1, 0FEh
byte_E8DD:	db 14h,	0, 14h,	1, 1, 2, 0FFh

npc08sprData:	incbin "npcspr/npc08spr.bin"

; npc 09

npc09sprTab:	dw stru_E9B2
		dw stru_E9B7
		dw stru_E9BC
		dw stru_E9C1
		dw stru_E9C6
		dw emptySpr
		
npc09aniTab:	dw byte_E9CB

stru_E9B2:	SPRITE 2, 2, npc09sprData, 1
stru_E9B7:	SPRITE 2, 2, npc09sprData+40h, 1
stru_E9BC:	SPRITE 2, 4, npc09sprData+80h, 11h
stru_E9C1:	SPRITE 2, 4, npc09sprData+100h, 11h
stru_E9C6:	SPRITE 2, 4, npc09sprData+180h, 11h

byte_E9CB:	db 0F7h, 3, 0, 3, 2, 3,	3, 3, 2, 3, 4, 3, 3, 3,	0, 3
		db 2, 3, 4, 3, 3, 3, 1,	3, 3, 3, 1, 3, 2, 3, 1,	3
		db 5, 3, 1, 3, 5, 0F5h,	0C8h, 3Fh, 0, 0FFh
		
npc09sprData:	incbin "npcspr/npc09spr.bin"

; npc 22,23,24,25
npc22sprTab:	dw stru_EC0F
		dw stru_EC14
		
npc23sprTab:	dw stru_EC19
		dw stru_EC1E
		
npc24sprTab:	dw stru_EC23
		dw stru_EC28
		
npc25sprTab:	dw stru_EC2D
		dw stru_EC32
		
npc22aniTab:	dw byte_EC37
		dw byte_EC3C
		dw byte_EC41
		dw byte_EC46
		dw byte_EC4B
		
stru_EC0F:	SPRITE 2, 2, npc22sprData, 0
stru_EC14:	SPRITE 2, 2, npc22sprData+80h, 0
stru_EC19:	SPRITE 2, 2, npc22sprData+20h, 0
stru_EC1E:	SPRITE 2, 2, npc22sprData+0A0h, 0
stru_EC23:	SPRITE 2, 2, npc22sprData+40h, 0
stru_EC28:	SPRITE 2, 2, npc22sprData+0C0h, 0
stru_EC2D:	SPRITE 2, 2, npc22sprData+60h, 0
stru_EC32:	SPRITE 2, 2, npc22sprData+0E0h, 0

byte_EC37:	db 0F5h, 0Ah, 12h, 0, 4
byte_EC3C:	db 0F5h, 0Ah, 14h, 0, 4
byte_EC41:	db 0F5h, 0Ah, 22h, 0, 4
byte_EC46:	db 0F5h, 0Ah, 24h, 0, 4
byte_EC4B:	db 0F7h, 0F8h, 1, 0, 0F2h, 14h,	2, 0Ah,	1, 0FEh

npc22sprData:	incbin "npcspr/npc22spr.bin"

; npc 0a

npc0AsprTab:	dw stru_ED5D
		dw stru_ED62
		
npc0AaniTab:	dw byte_ED67
		dw byte_ED6E
		
stru_ED5D:	SPRITE 2, 2, npc0AsprData, 1
stru_ED62:	SPRITE 2, 2, npc0AsprData+40h, 1

byte_ED67:	db 0F7h, 0F8h, 14h, 0, 14h, 1, 0FEh
byte_ED6E:	db 5, 0, 5, 1, 5, 0, 5,	1, 5, 0, 5, 1, 5, 0, 5,	1
		db 5, 0, 5, 1, 5, 0, 5,	1, 5, 0, 5, 1, 5, 0, 5,	1
		db 5, 0, 5, 1, 5, 0, 5,	1, 0FFh
		
npc0AsprData:	incbin "npcspr/npc0Aspr.bin"

; npc 0b

npc0BsprTab:	dw stru_EE25
		dw stru_EE2A
		dw stru_EE2F
		dw stru_EE34
		
npc0BaniTab:	dw byte_EE39
		dw byte_EE44
		dw byte_EE47
		
stru_EE25:	SPRITE 2, 2, npc0BsprData, 1
stru_EE2A:	SPRITE 2, 2, npc0BsprData+40h, 1
stru_EE2F:	SPRITE 2, 2, npc0BsprData+80h, 1
stru_EE34:	SPRITE 2, 2, npc0BsprData+0C0h, 1

byte_EE39:	db 0F7h, 0F8h, 19h, 0, 0F2h, 0B4h, 1, 0FEh, 19h, 1, 0FEh
byte_EE44:	db 1, 3, 0FFh
byte_EE47:	db 1, 2, 0FFh

npc0BsprData:	incbin "npcspr/npc0Bspr.bin"

; npc 0c

npc0CsprTab:	dw stru_EF58
		dw stru_EF5D
		dw stru_EF62
		dw stru_EF67
		
npc0CaniTab:	dw byte_EE39
		dw byte_EE44
		dw byte_EE47
		
stru_EF58:	SPRITE 2, 2, npc0CsprData, 1
stru_EF5D:	SPRITE 2, 2, npc0CsprData+40h, 1
stru_EF62:	SPRITE 2, 4, npc0CsprData+80h, 11h
stru_EF67:	SPRITE 2, 2, npc0CsprData+100h, 1

npc0CsprData:	incbin "npcspr/npc0Cspr.bin"

; npc 0d,0e

npc0DsprTab:	dw stru_F0BE
		dw stru_F0C3
		dw stru_F0C8
		dw stru_F0CD
		dw stru_E9B7
		dw emptySpr
		
npc0DaniTab:	dw byte_F0D2
		dw byte_F0DD
		dw byte_F0E8
		
stru_F0BE:	SPRITE 2, 2, npc0DsprData, 1
stru_F0C3:	SPRITE 2, 2, npc0DsprData+40h, 1
stru_F0C8:	SPRITE 2, 2, npc0DsprData+80h, 1
stru_F0CD:	SPRITE 2, 2, npc0DsprData+0C0h, 1

byte_F0D2:	db 0F7h, 0F8h, 0Ah, 3, 0Ah, 2, 0Ah, 1, 0Ah, 0, 0FEh
byte_F0DD:	db 0F7h, 0F8h, 0Ah, 0, 0Ah, 1, 0Ah, 2, 0Ah, 3, 0FEh
byte_F0E8:	db 0F7h, 0F8h, 3, 0, 3,	4, 3, 1, 3, 4, 3, 5, 3,	4, 3, 5
		db 3, 4, 3, 5, 0F5h, 20h, 1Bh, 0, 1
		
npc0DsprData:	incbin "npcspr/npc0Dspr.bin"

; npc 0f

npc0FsprTab:	dw stru_F20D
		dw stru_F212
		dw stru_E9B7
		dw emptySpr
		
npc0FaniTab:	dw byte_F217
		dw byte_F21D
		
stru_F20D:	SPRITE 2, 2, npc0FsprData, 1
stru_F212:	SPRITE 2, 2, npc0FsprData+40h, 1

byte_F217:	db 0F7h, 0F5h, 20h, 33h, 0, 1
byte_F21D:	db 0F7h, 0Ah, 2, 5, 3, 0Ah, 2, 5, 3, 0Ah, 2, 0Fh, 0, 0Ah, 2, 1
		db 0, 0F8h, 14h, 0, 7, 1, 0FEh
		
npc0FsprData:	incbin "npcspr/npc0Fspr.bin"

; npc 10,11,12

npc10sprTab:	dw stru_F2C6
		dw stru_F2CB
		dw stru_F2D0
		dw stru_F2D5
		dw stru_F2DA
		dw stru_F2DF
		
npc10aniTab:	dw byte_F2E4
		dw byte_F2EF
		dw byte_F2F6
		
stru_F2C6:	SPRITE 2, 2, npc10sprData, 1
stru_F2CB:	SPRITE 2, 2, npc10sprData+40h, 1
stru_F2D0:	SPRITE 2, 2, npc10sprData+80h, 1
stru_F2D5:	SPRITE 2, 2, npc10sprData+0C0h, 1
stru_F2DA:	SPRITE 2, 2, npc10sprData+100h, 1
stru_F2DF:	SPRITE 2, 2, npc10sprData+140h, 1

byte_F2E4:	db 0F7h, 0F8h, 0Fh, 1, 0F2h, 0C8h, 1, 0FEh, 14h, 0, 0FEh
byte_F2EF:	db 0F7h, 0F8h, 0Fh, 2, 0Fh, 3, 0FEh
byte_F2F6:	db 1, 5, 0FFh

npc10sprData:	incbin "npcspr/npc10spr.bin"

; npc 13

npc13sprTab:	dw stru_F485
		dw stru_F48A
		dw stru_F48F
		
npc13aniTab:	dw byte_F494
		dw byte_F497
		dw byte_EE47
		
stru_F485:	SPRITE 2, 2, npc13sprData, 1
stru_F48A:	SPRITE 2, 2, npc13sprData+40h, 1
stru_F48F:	SPRITE 2, 2, npc13sprData+80h, 1

byte_F494:	db 1, 1, 0FFh
byte_F497:	db 1, 3, 0FFh

npc13sprData:	incbin "npcspr/npc13spr.bin"

; npc 14, 15

npc14sprTab:	dw stru_F566
		dw stru_F56B
		
npc14aniTab:	dw byte_F57A

npc15sprTab:	dw stru_F570
		dw stru_F575
		
npc15aniTab:	dw byte_F57A

stru_F566:	SPRITE 2, 2, byte_F581, 1
stru_F56B:	SPRITE 2, 2, byte_F581+40h, 1
stru_F570:	SPRITE 2, 2, byte_F581+80h, 1
stru_F575:	SPRITE 2, 2, byte_F581+0C0h, 1

byte_F57A:	db 0F7h, 0F8h, 0Ah, 0, 0Ah, 1, 0FEh

byte_F581:	incbin "npcspr/npc14spr.bin"

; npc 1d, 1e

npc1DsprTab:	dw stru_E49D
		dw stru_E4A2
		dw stru_E4A7
		
npc1DaniTab:	dw byte_E4D2

; npc 17

npc17sprTab:	dw stru_F68B

stru_F68B:	SPRITE 2, 2, npc17sprData, 1

npc17sprData:	incbin "npcspr/npc17spr.bin"

; npc 18

npc18sprTab:	dw stru_F6D6
		dw stru_F6DB
		dw stru_F6E0
		
stru_F6D6:	SPRITE 2, 2, npc18sprData, 1
stru_F6DB:	SPRITE 2, 2, npc18sprData+40h, 1
stru_F6E0:	SPRITE 2, 2, npc18sprData+80h, 1

npc18sprData:	incbin "npcspr/npc18spr.bin"

; npc 19

npc19sprTab:	dw stru_F7A9
		dw stru_F7AE
		
stru_F7A9:	SPRITE 2, 2, npc19sprData, 1
stru_F7AE:	SPRITE 2, 2, npc19sprData+40h, 1

npc19sprData:	incbin "npcspr/npc19spr.bin"

; npc 1c

npc1CsprTab:	dw stru_F839
		dw stru_F83E
		
npc1CaniTab:	dw byte_F843

stru_F839:	SPRITE 2, 2, npc1CsprData, 1
stru_F83E:	SPRITE 2, 2, npc1CsprData+40h, 1

byte_F843:	db 0F7h, 0F8h, 0Fh, 0, 0F2h, 0E6h, 1, 0FEh, 5, 1, 5, 0,	5, 1, 5, 0
		db 5, 1, 0FEh
		
npc1CsprData:	incbin "npcspr/npc1Cspr.bin"

; npc 1f

npc1FsprTab:	dw stru_F8E2
		dw stru_F8E7
		dw stru_F8EC
		dw emptySpr
		
npc1FaniTab:	dw byte_F8F1
		dw byte_F8FA
		
stru_F8E2:	SPRITE 2, 2, npc1FsprData, 1
stru_F8E7:	SPRITE 2, 2, npc1FsprData+40h, 1
stru_F8EC:	SPRITE 2, 2, npc1FsprData+80h, 1

byte_F8F1:	db 0F7h, 0F8h, 5, 0, 5,	1, 5, 2, 0FEh
byte_F8FA:	db 0F7h, 0F8h, 1, 3, 0F5h, 0C9h, 0, 0, 0FFh

npc1FsprData:	incbin "npcspr/npc1Fspr.bin"

; npc 20

npc20sprTab:	dw stru_F9C7

npc20aniTab:	dw noAnim

stru_F9C7:	SPRITE 2, 2, npc20sprData, 1

npc20sprData:	incbin "npcspr/npc20spr.bin"

; npc 1b

npc1BsprTab:	dw stru_FA10

npc1BaniTab:	dw noAnim

stru_FA10:	SPRITE 2, 2, npc1BsprData, 1

npc1BsprData:	incbin "npcspr/npc1Bspr.bin"
		
; npc 21

npc21sprTab:	dw stru_FA6B
		dw stru_FA70
		dw stru_FA75
		dw stru_FA7A
		dw stru_FA7F
		dw stru_FA84
		dw emptySpr
		
npc21aniTab:	dw byte_FA89
		dw byte_FA8F
		dw byte_FAC5
		dw byte_FACC
		
stru_FA6B:	SPRITE 2, 2, npc21sprData, 1
stru_FA70:	SPRITE 2, 2, npc21sprData+40h, 1
stru_FA75:	SPRITE 2, 2, npc21sprData+80h, 1
stru_FA7A:	SPRITE 2, 3, npc21sprData+0C0h, 11h
stru_FA7F:	SPRITE 2, 2, npc21sprData+120h, 1
stru_FA84:	SPRITE 2, 2, npc21sprData+160h, 1

byte_FA89:	db 0F7h, 0F5h, 55h, 6, 0, 1
byte_FA8F:	db 0F7h, 0F8h, 5, 0, 5,	1, 5, 2, 0F7h, 0F9h, 0,	0F6h, 5, 3, 0F4h, 5
		db 0, 5, 1, 5, 2, 0F7h,	0F9h, 0, 0F6h, 5, 3, 0F4h, 5, 0, 5, 1
		db 5, 2, 0F7h, 0F9h, 0,	0F6h, 5, 3, 0F4h, 5, 0,	5, 1, 5, 2, 1
		db 6, 0F5h, 55h, 26h, 4, 2
byte_FAC5:	db 0F7h, 0F8h, 0Fh, 4, 0Fh, 5, 0FEh
byte_FACC:	db 1, 6, 0F5h, 0C9h, 2,	0, 0FFh

npc21sprData:	incbin "npcspr/npc21spr.bin"

; npc 26..2b

npc26sprTab:	dw stru_FC83
		dw stru_FC88
		dw stru_FC8D
		dw stru_FC92
		dw stru_FC97
		dw stru_FC9C
		dw stru_FCA1
		
npc26aniTab:	dw byte_FCA6

stru_FC83:	SPRITE 2, 2, npc26sprData, 1
stru_FC88:	SPRITE 2, 2, npc26sprData+40h, 1
stru_FC8D:	SPRITE 2, 2, npc26sprData+80h, 1
stru_FC92:	SPRITE 2, 2, npc26sprData+0C0h, 1
stru_FC97:	SPRITE 2, 2, npc26sprData+100h, 1
stru_FC9C:	SPRITE 2, 2, npc26sprData+140h, 1
stru_FCA1:	SPRITE 2, 2, npc26sprData+180h, 1

byte_FCA6:	db 0F7h, 5, 3, 5, 4, 5,	5, 5, 6, 0F8h, 5, 1, 5,	2, 0FEh

npc26sprData:	incbin "npcspr/npc26spr.bin"

; npc 2c

npc2CsprTab:	dw stru_FE81
		dw stru_FE86
		dw stru_FE8B
		dw stru_FE90
		dw emptySpr
		
npc2CaniTab:	dw byte_FE95

stru_FE81:	SPRITE 2, 2, byte_FEB9, 1
stru_FE86:	SPRITE 2, 2, byte_FEB9+40h, 1
stru_FE8B:	SPRITE 2, 2, byte_FEB9+80h, 1
stru_FE90:	SPRITE 2, 2, byte_FEB9+0C0h, 1

byte_FE95:	db 0F7h, 5, 0, 5, 1, 5,	2, 5, 3, 5, 2, 5, 3, 5,	2, 5
		db 3, 5, 2, 5, 3, 5, 2,	5, 3, 5, 1, 5, 0, 5, 4,	0F5h
		db 65h,	0, 0, 0FFh
		
byte_FEB9:	incbin "npcspr/npc2Cspr.bin"

; empty spr / stop ani

emptySpr:	SPRITE 2, 2, emptySprData, 1

emptySprData:	dup 32
		db 0xff, 0x00
		edup

noAnim:	db 0FFh			; RAM:npc20aniTabo RAM:npc1BaniTabo
