; VQ2. rampage 1

	MACRO DB4W b1,b2,b3,b4,wrd
	 db b1,b2,b3,b4
	 dw wrd
	ENDM

	MACRO DB3W b1,b2,b3,wrd
	 db b1,b2,b3
	 dw wrd
	ENDM
	
	MACRO DB2W b1,b2,wrd
	 db b1,b2
	 dw wrd
	ENDM

exeExt01:	cp	maxExt1func
		ret	nc
		push	hl
		ld	hl, ext1funcTab
		add	a, a
		add	a, l
		ld	l, a
		jr	nc, ex1_C00D
		inc	h
ex1_C00D:	ld	a, (hl)
		inc	hl
		ld	h, (hl)
		ld	l, a
		ex	(sp), hl
		ret
; ---------------------------------------------------------------------------
ext1funcTab:	dw initBits		; 00: init bits (all 0)
		dw prnFinalString	; 01: print final text C (0..4)
		dw drawSpells		; 02: redraw spells
		dw talkNpcB		; 03: talk with npc B
		dw pickDropGive		; 04: pick/drop/give current item
		dw useItem		; 05: use current item
		dw castSpell		; 06: cast current spell
		dw extBattle		; 07: act battle (if any)
maxExt1func	equ ($ - ext1funcTab) / 2

initBits:	ld	hl, bitsTab
		ld	b, 8
ex1_C028:	ld	(hl), 0
		inc	hl
		djnz	ex1_C028
		ret
		
; set npc anims: 2 to npc#10, 2 to npc#11, 0 to npc#13

ex1_C02E:	ld	b, 10h
		ld	c, 2
		ld	a, 2
		call	ovFuncExt0
		ld	b, 11h
		ld	c, 2
		ld	a, 2
		call	ovFuncExt0
		ld	b, 13h
		ld	c, 0
		ld	a, 2
		jp	ovFuncExt0
		
extBattle:	ld	b, 0		; H = npc in front of hero (b=0)
		ld	a, 6
		call	ovFuncExt0
		ld	c, h
		inc	h
		scf
		ret	z
		ld	hl, battleTab
ex1_C057:	ld	a, (hl)
		inc	hl
		cp	c
		jr	z, ex1_C063
		inc	a
		scf
		ret	z
		inc	hl
		inc	hl
		jr	ex1_C057
ex1_C063:	push	hl
		ld	hl, atrPaternA
		call	msgWindowAtrs
		pop	hl
		ld	a, (hl)
		inc	hl
		ld	h, (hl)
		ld	l, a
		call	ext1_callHL
sub_C072:	ld	hl, atrPaternDef
		jp	msgWindowAtrs

atrPaternA:	db 5, 7		; pattern for battle
		db 2, 4
		db 2, 2
		db 21, 7
		db 0

atrPaternDef:	db 7, 7		; default pattern
		db 23, 4
		db 0

ext1_callHL:	jp	(hl)

; battle tab : npcid, <exe.adr>

battleTab:	IDADR 0Bh, ex1_C0B5
		IDADR 0Ch, ex1_C0E3
		IDADR 13h, ex1_C091
		db 0FFh

; battle 02 : boar, npc 0x13 (19)

ex1_C091:	ld	b, 13h		; C = boar sprite nr
		ld	a, 8
		call	ovFuncExt0
		dec	c
		scf
		ret	nz
		ld	b, 13h		; set boar animation 2
		ld	c, 2
		ld	a, 2
		call	ovFuncExt0
		ld	hl, 4B0h
		ld	e, 2
		call	doBattle
		ld	c, 12h		; get item 0x12 (boar head)
		ld	a, 0Bh
		call	ovFuncExt0
		and	a
		ret

; battle 00 : wolf

ex1_C0B5:	ld	b, 0Bh		; C = anim.nr of npc 11
		ld	a, 7
		call	ovFuncExt0
		ld	a, c
		and	a
		scf
		ret	nz
		ld	b, 0Bh		; set npc 11 anim 2
		ld	c, 2
		ld	a, 2
		call	ovFuncExt0
		ld	hl, 3D0h
		ld	e, 0
		call	doBattle
		ld	b, 0Bh		; set npc 11 anim 1 (death)
		ld	c, 1
		ld	a, 2
		call	ovFuncExt0
		ld	c, 0Ch		; get item 12
		ld	a, 0Bh
		call	ovFuncExt0
		and	a
		ret
		
; battle 01 : bear

ex1_C0E3:	ld	b, 0Ch
		ld	a, 7
		call	ovFuncExt0
		ld	a, c
		and	a
		scf
		ret	nz
		ld	b, 0Ch
		ld	c, 2
		ld	a, 2
		call	ovFuncExt0
		ld	hl, 6C8h
		ld	e, 1
		call	doBattle
		ld	b, 0Ch
		ld	c, 1
		ld	a, 2
		call	ovFuncExt0
		ld	c, 9
		ld	a, 0Bh
		call	ovFuncExt0
		and	a
		ret

; cast current spell on NPC (yep, stone in a cave is NPC)

castSpell:	ld	b, 0
		ld	a, 6
		call	ovFuncExt0
		ld	b, h
		inc	h
		scf
		ret	z
		ld	hl, castTab
		ld	a, (curSpell)
		ld	c, a
ex1_C123:	ld	a, (hl)
		cp	0FFh
		scf
		ret	z
		cp	c
		inc	hl
		jr	nz, ex1_C130
		ld	a, (hl)
		cp	b
		jr	z, ex1_C135
ex1_C130:	inc	hl
		inc	hl
		inc	hl
		jr	ex1_C123
ex1_C135:	inc	hl
		ld	a, (hl)
		inc	hl
		ld	h, (hl)
		ld	l, a
		jp	(hl)

; cast tab : spellID, npcID, <exe.adr>

castTab:	DB2W 1, 9, castSpell1_9
		db 0FFh

castSpell1_9:	ld	b, 9		; cast lightning to destroy stone
		ld	c, 0
		ld	a, 2
		call	ovFuncExt0
		ld	d, 3
		ld	a, 0Eh
		call	ovEngineFunc
		and	a
		ret

; === USE
; use current item

useItem:	ld	a, 0Dh		; C = cur.item.id
		call	ovFuncExt0
		ld	a, c
		and	a
		scf
		ret	z
		push	bc
		ld	a, 6		; get H:npc/L:item/A:tile ahead
		call	ovFuncExt0
		pop	de		; E = cur.item
		ld	d, h		; D = npc.id
		ld	(ex1_C187+1), a
		ld	hl, useTab
ex1_C169:	ld	a, (hl)
		inc	hl
		ex	af, af'
		ld	a, e
		cp	(hl)
		inc	hl
		jr	z, ex1_C177
ex1_C171:	inc	hl
ex1_C172:	inc	hl
		inc	hl
		inc	hl
		jr	ex1_C169
ex1_C177:	ex	af, af'
		and	a
		jr	z, ex1_C1A0
		dec	a
		jr	z, ex1_C19C
		dec	a
		jr	z, ex1_C18D
		dec	a
		jr	z, ex1_C186
		scf
		ret
ex1_C186:	ld	a, (hl)		; check tile.nr
ex1_C187:	cp	0
		jr	nz, ex1_C171
		jr	ex1_C1A0
ex1_C18D:	ld	a, (hl)		; check map,crd
		cp	b
		jr	nz, ex1_C171
		inc	hl
		ld	a, (hl)
		cp	c
		jr	nz, ex1_C172
ex1_C196:	inc	hl		; always
		ld	a, (hl)
		inc	hl
		ld	h, (hl)
		ld	l, a
		jp	(hl)
ex1_C19C:	ld	a, (hl)		; check npc.id
		cp	d
		jr	nz, ex1_C171
ex1_C1A0:	inc	hl
		jr	ex1_C196

; 0, itemID, *, *, <exe.adr>		use item
; 1, itemID, npcID, *, <exe.adr>	use item on npc
; 2, itemID, map, crd, <exe.adr>	use item on place (map, crd)
; 3, itemID, tile, *, <exe.adr>		use item on tile

useTab:		DB4W 1, 3, 6, 0, ex1_C306
		DB4W 1, 4, 6, 0, ex1_C331
		DB4W 1, 14h, 16h, 0, ex1_C256
		DB4W 1, 18h, 1Fh, 0, ex1_C1FF
		DB4W 3, 2, 8Ch, 0, ex1_C2EF
		DB4W 3, 0Ah, 0EFh, 0, ex1_C2CC
		DB4W 3, 13h, 0DBh, 0, ex1_C26D
		DB4W 3, 16h, 0DCh, 0, ex1_C222
		DB4W 3, 1Ah, 0E9h, 0, ex1_C1E6
		DB4W 0, 0Eh, 0, 0, ex1_C2A1
		DB4W 0, 0Fh, 0, 0, ex1_C2A5
		db 0FFh
; ---------------------------------------------------------------------------

ex1_C1E6:	ld	c, 1Ah		; del item 0x1a
		ld	a, 0Ch
		call	ovFuncExt0
		ld	b, 21h		; set anim 0 to npc 0x21
		ld	c, 0
		ld	a, 2
		call	ovFuncExt0
		ld	d, 2		; add 2 exp
		ld	a, 0Eh
		call	ovEngineFunc
		and	a
		ret
; ---------------------------------------------------------------------------

ex1_C1FF:	ld	c, 18h		; del item 0x18
		ld	a, 0Ch
		call	ovFuncExt0
		ld	b, 1Fh		; set anim 1 to npc 0x1f
		ld	c, 1
		ld	a, 2
		call	ovFuncExt0
		ld	a, 1Ch		; set bits 0x1c, 0x1d
		call	setBit
		ld	a, 1Dh
		call	setBit
		ld	d, 2		; add 2 exp
		ld	a, 0Eh
		call	ovEngineFunc
		and	a
		ret
; ---------------------------------------------------------------------------

ex1_C222:	ld	c, 16h		; del item 0x16
		ld	a, 0Ch
		call	ovFuncExt0
		ld	bc, 3914h	; map 0x39, crd 0x14, put tile 0x27
		ld	d, 27h
		call	sub_C246
		inc	c		; map 0x39, crd 0x15, put tile 0x2b
		ld	d, 2Bh
		call	sub_C246
		inc	c		; map 0x39, crd 0x16, put tile 0x27
		ld	d, 27h
		call	sub_C246
		ld	d, 2		; add 2 exp
		ld	a, 0Eh
		call	ovEngineFunc
		and	a
		ret

; put tile D on map B crd C & redraw it

sub_C246:	ld	a, 8
		call	ovEngineFunc
		push	bc
		push	de
		ld	a, 0Bh
		call	ovEngineFunc
		pop	de
		pop	bc
		and	a
		ret

; ---------------------------------------------------------------------------

ex1_C256:	ld	c, 14h		; del item 0x14
		ld	a, 0Ch
		call	ovFuncExt0
		ld	c, 15h		; add item 0x15
		ld	a, 0Bh
		call	ovFuncExt0
		ld	d, 2		; add 2 exp
		ld	a, 0Eh
		call	ovEngineFunc
		and	a
		ret
; ---------------------------------------------------------------------------

ex1_C26D:	ld	c, 13h		; del item 0x13
		ld	a, 0Ch
		call	ovFuncExt0
		ld	de, 2704h	; put row of 4 tiles 0x27 on map 0x33, crd 0x0a
		ld	bc, 330Ah
		call	sub_C28D
		ld	e, 4		; and 4 from crd 0x12
		ld	c, 12h
		call	sub_C28D
		ld	d, 2		; add 2 exp
		ld	a, 0Eh
		call	ovEngineFunc
		and	a
		ret

; put row of E tiles D start from (map B, crd C)
sub_C28D:	ld	a, 8
		call	ovEngineFunc
		push	bc
		push	de
		ld	a, 0Bh
		call	ovEngineFunc
		pop	de
		pop	bc
		inc	c
		dec	e
		jr	nz, sub_C28D
		and	a
		ret

; ---------------------------------------------------------------------------

ex1_C2A1:	ld	c, 0Fh
		jr	ex1_C2A7
ex1_C2A5:	ld	c, 0Eh
ex1_C2A7:	ld	a, 0Eh		; check item C
		call	ovFuncExt0
		scf
		ret	nz
		ld	c, 0Eh		; del item 0x0e
		ld	a, 0Ch
		call	ovFuncExt0
		ld	c, 0Fh		; del item 0x0f
		ld	a, 0Ch
		call	ovFuncExt0
		ld	c, 10h		; add item 0x10
		ld	a, 0Bh
		call	ovFuncExt0
		ld	d, 2		; add 2 exp
		ld	a, 0Eh
		call	ovEngineFunc
		and	a
		ret
; ---------------------------------------------------------------------------

ex1_C2CC:	ld	c, 0Ah		; del item 0x0a
		ld	a, 0Ch
		call	ovFuncExt0
		ld	bc, 2621h	; put tile 0xF9 on map 0x26, crd 0x21
		ld	d, 0F9h
		ld	a, 8
		call	ovEngineFunc
		ld	d, 0F9h		; draw tile 0xf9 on crd 0x21
		ld	c, 21h
		ld	a, 0Bh
		call	ovEngineFunc
		ld	d, 2		; add 2 exp
		ld	a, 0Eh
		call	ovEngineFunc
		and	a
		ret
; ---------------------------------------------------------------------------

ex1_C2EF:	ld	c, 2		; del item 2
		ld	a, 0Ch
		call	ovFuncExt0
		ld	c, 4		; add item 4
		ld	a, 0Bh
		call	ovFuncExt0
		ld	d, 2		; add 2 exp
		ld	a, 0Eh
		call	ovEngineFunc
		and	a
		ret
; ---------------------------------------------------------------------------

ex1_C306:	ld	c, 3		; del item 3
		ld	a, 0Ch
		call	ovFuncExt0
		ld	b, 7		; spr 1 to npc 7
		ld	c, 1
		ld	a, 3
		call	ovFuncExt0
		ld	b, 6		; ani 255 to npc 6 (stop ani)
		ld	c, 0FFh
		ld	a, 2
		call	ovFuncExt0
		ld	b, 6		; spr 3 to npc 6
		ld	c, 3
		ld	a, 3
		call	ovFuncExt0
		ld	d, 2		; add 2 exp
		ld	a, 0Eh
		call	ovEngineFunc
		and	a
		ret
; ---------------------------------------------------------------------------

ex1_C331:	ld	a, 7		; C = anim of npc B
		ld	b, 6
		call	ovFuncExt0
		inc	c
		scf
		ret	nz
		ld	c, 4		; del item 4
		ld	a, 0Ch
		call	ovFuncExt0
		halt
		ld	b, 6		; anim 0 to npc 6
		ld	c, 0
		ld	a, 2
		call	ovFuncExt0
		ld	d, 2		; add 2 exp
		ld	a, 0Eh
		call	ovEngineFunc
		and	a
		ret
		
; end of use items
; ---------------------------------------------------------------------------
; pick, drop or give item

pickDropGive:	ld	b, 0		; get H:npc/L:item/A:tile ahead of npc 0
		ld	a, 6
		call	ovFuncExt0
		ld	c, a	; C = tile
		ld	a, b	; if map != D ret
		cp	d
		scf
		ret	nz
		inc	l		; item ahead
		jp	nz, ex1_C550
		inc	h		; npc ahead
		jp	nz, ex1_C55D
		rl	c		; if tile.nr > 127, ret
		ret	c
		ld	a, 0Dh		; C = cur.item
		call	ovFuncExt0
		ld	a, c		; empty: ret
		and	a
		scf
		ret	z
		cp	1Bh		; if item 0x1b
		jr	z, ex1_C3EF
		cp	10h		; if item not 0x10
		jr	nz, ex1_C394
		push	bc
		ld	b, 0		; get ahead (again?)
		ld	a, 6
		call	ovFuncExt0
		pop	bc
		sub	21h		; if tile nr not in 0x21..0x27
		cp	6
		jr	nc, ex1_C394
		ld	a, d		; if map in front = 0x31 | = 0x32
		sub	31h
		cp	2
		jp	c, ex1_C417

ex1_C394:	ld	hl, putSignsTab	; check : drop on place
ex1_C397:	ld	a, (hl)
		cp	0FFh
		jr	z, ex1_C3B6
		cp	c
		jr	nz, ex1_C3AF
		inc	hl
		ld	a, (hl)
		cp	d
		jr	nz, ex1_C3B0
		inc	hl
		ld	a, (hl)
		cp	e
		jr	nz, ex1_C3B1
		inc	hl
		ld	a, (hl)
		inc	hl
		ld	h, (hl)
		ld	l, a
		jp	(hl)
ex1_C3AF:	inc	hl
ex1_C3B0:	inc	hl
ex1_C3B1:	inc	hl
		inc	hl
		inc	hl
		jr	ex1_C397

ex1_C3B6:	ld	a, 0Dh		; check : drop on map (drop light in cave -> death)
		call	ovFuncExt0	; C = cur.item
		ld	hl, dropOnMapTab
ex1_C3BE:	ld	a, (hl)
		cp	0FFh
		jr	z, ex1_C3D8
		inc	hl
		cp	c
		jr	nz, ex1_C3CD
		ld	a, (curMapNr)
		cp	(hl)
		jr	z, ex1_C3D2
ex1_C3CD:	inc	hl
		inc	hl
		inc	hl
		jr	ex1_C3BE
ex1_C3D2:	inc	hl
		ld	a, (hl)
		inc	hl
		ld	h, (hl)
		ld	l, a
		jp	(hl)

ex1_C3D8:	ld	a, 0Fh		; drop item C on map D crd E
		call	ovFuncExt0
		push	af
		call	fNoFire
		pop	af
		ld	b, 0		; get all in front
		ld	a, 6
		call	ovFuncExt0
		push	af
		call	fNoFire
		pop	af
		ret			; return A = tile ?

ex1_C3EF:	ld	hl, asc_FB60	; can't drop item 0x1b
		call	printString4
		and	a
		ret

; drop item on map
; itemID, map, <exe.adr>

dropOnMapTab:	DB2W 1, 11h, ex1_C410	; DATA XREF: RAM:C3BBo
		DB2W 1, 12h, ex1_C410
		DB2W 1, 13h, ex1_C410
		DB2W 1, 14h, ex1_C410
		DB2W 1, 15h, ex1_C410
		DB2W 1, 16h, ex1_C410
		db 0FFh

ex1_C410:	ld	a, 5		; game over 0 (death in dark)
		ld	c, 0
		jp	ovEngineFunc
; ---------------------------------------------------------------------------
; put trap on boar road

ex1_C417:	ld	c, 10h		; del item 16 (trap)
		ld	a, 0Ch
		push	de
		call	ovFuncExt0
		pop	hl
		ld	de, 0FFh	; move npc 0x13 to place in front of hero, set spr 0, ani FF
		ld	b, 13h
		ld	a, 11h
		call	ovFuncExt0
		ld	a, 11h		; set bit 17
		call	setBit
		and	a
		ret
; ---------------------------------------------------------------------------
; drop item on place in front (signs!)
; itemID, map, crd, <exe.adr>

putSignsTab:	DB3W 6, 0Ah, 14h, ex1_C4E3
		DB3W 0Dh, 0Ah, 12h, ex1_C4BC
		DB3W 17h, 0Ah, 22h, ex1_C483
		DB3W 1Dh, 0Ah, 24h, ex1_C446
		db 0FFh

; put sign 4

ex1_C446:	ld	c, 1Dh		; del item 0x1d
		ld	a, 0Ch
		call	ovFuncExt0
		ld	b, 25h		; set anim 3 to npc 0x25
		ld	c, 3
		ld	a, 2
		call	ovFuncExt0
		ld	b, 3		; set anim 3 to npc 3
		ld	c, 3
		ld	a, 2
		call	ovFuncExt0
		ld	c, 2		; fill map atr 2 (red)
		ld	a, 0Ch
		call	ovEngineFunc
		ld	b, 64h		; wait 2 sec
ex1_C468:	halt
		djnz	ex1_C468
		ld	a, 11h		; move npc 1 to map 100, crd 0x1b, set spr 5, ani 0xff
		ld	b, 1
		ld	hl, 0x641B
		ld	de, 5FFh
		call	ovFuncExt0
		ld	de, 0x643B	; warp to map 100, crd 0x3b
		ld	c, 5
		call	warpNpc
		jp	loc_DA54

; put sign 3

ex1_C483:	ld	c, 17h		; del item 0x17
		ld	a, 0Ch
		call	ovFuncExt0
		ld	b, 24h		; set npc 0x24 ani 2
		ld	c, 2
		ld	a, 2
		call	ovFuncExt0
		ld	b, 3		; set npc 3 ani 2
		ld	c, 2
		ld	a, 2
		call	ovFuncExt0
		ld	c, 2		; fill map atr 2
		ld	a, 0Ch
		call	ovEngineFunc
		ld	a, 11h		; move npc 5 to map 0x4e, npc 0x0e, spr 0, ani 0xff
		ld	b, 5
		ld	hl, 4E0Eh
		ld	de, 0FFh
		call	ovFuncExt0
		ld	a, 16h		; set bit 0x16
		call	setBit
		ld	de, 461Bh	; warp to map 0x46, crd 0x1b
		ld	c, 4
		jr	warpNpc

; put sign 2

ex1_C4BC:	ld	c, 0Dh		; del item 13
		ld	a, 0Ch
		call	ovFuncExt0
		ld	b, 22h		; set npc 0x22 ani 0
		ld	c, 0
		ld	a, 2
		call	ovFuncExt0
		ld	b, 3		; set npc 3 ani 1
		ld	c, 1
		ld	a, 2
		call	ovFuncExt0
		ld	c, 2		; fill map atr 2
		ld	a, 0Ch
		call	ovEngineFunc
		ld	de, 2912h	; warp to map 0x29, crd 0x12
		ld	c, 3
		jr	warpNpc

; put sign 1

ex1_C4E3:	ld	c, 6		; del item 6
		ld	a, 0Ch
		call	ovFuncExt0
		ld	b, 23h		; set npc 0x23 ani 1
		ld	c, 1
		ld	a, 2
		call	ovFuncExt0
		ld	b, 3		; set npc 3 ani 0
		ld	c, 0
		ld	a, 2
		call	ovFuncExt0
		ld	c, 2		; fill map atr 2
		ld	a, 0Ch
		call	ovEngineFunc
		ld	de, 190Dh	; warp to map 0x19, crd 0x0d
		ld	c, 2
warpNpc:	ld	b, 32h
ex1_C50A:	halt
		djnz	ex1_C50A
ex1_C50D:	push	bc
		push	de
		ld	b, 0		; set anim 6 to hero
		ld	c, 6
		ld	a, 2
		call	ovFuncExt0
		ld	b, 0		; wait npc 0
		ld	a, 9
		call	ovFuncExt0
		call	aniOff
		pop	de
		ld	a, 0Dh		; ???
		ld	b, 0
		call	ovEngineFunc
		ld	b, 0		; wait npc 0
		ld	a, 9
		call	ovFuncExt0
		pop	bc
		ld	a, 12h		; fill map atr C
		call	ovEngineFunc
		ld	b, 0		; set anim 7 to npc 0
		ld	c, 7
		ld	a, 2
		call	ovFuncExt0
		ld	b, 0		; wait npc 0
		ld	a, 9
		call	ovFuncExt0
		ld	d, 5		; add 5 exp
		ld	a, 0Eh
		call	ovEngineFunc
		and	a
		ret

; ---------------------------------------------------------------------------
; pick up item L-1 from map
ex1_C550:	dec	l
		ld	c, l		; put it in bag
		ld	a, 10h
		call	ovFuncExt0
		push	af
		call	fNoFire
		pop	af
		ret
		
; ---------------------------------------------------------------------------
; give item C to NPC H-1

ex1_C55D:	dec	h
		ld	a, h		; if npc is 0x21 ("pick" npc)
		cp	21h
		jr	z, ex1_C572
		push	hl
		ld	a, 0Dh		; C = cur.item
		call	ovFuncExt0
		ld	a, c
		pop	bc
		ld	c, a		; B:npc, C:item
		ld	hl, giveTab
		jp	ex1_C123	; same using as in cast
ex1_C572:	ld	b, 21h		; set npc 0x21 anim 3
		ld	c, 3
		ld	a, 2
		call	ovFuncExt0
		ld	c, 1Bh		; put item 0x1b to bag
		ld	a, 0Bh
		call	ovFuncExt0
		and	a
		ret
; give list : itemID, npcID, <exe.adr>
giveTab:	DB2W 5, 5, givAmulWiz	; DATA XREF: RAM:C56Co
		DB2W 1, 5, ex1_C69F
		DB2W 7, 0Ah, givMoneySmith
		DB2W 0Ch, 0Dh,	ex1_C679
		DB2W 9, 0Eh, ex1_C643
		DB2W 0Bh, 0Eh,	ex1_C63F
		DB2W 12h, 12h,	givHeadMaster
		DB2W 15h, 15h,	givHairsWoman
		DB2W 7, 1Ch, givMoneyTrader
		DB2W 19h, 19h,	givLanternGuard
		DB2W 19h, 1Ah,	givLanternGuard
		DB2W 1Bh, 1Bh,	ex1_C5C9
		DB2W 1Ch, 18h,	givDragonMonk
		db 0FFh

givDragonMonk:	ld	c, 1Ch
		ld	a, 0Ch
		call	ovFuncExt0
		ld	hl, txt1_FAC5
		call	printString4
		jp	ex1_C77C

ex1_C5C9:	ld	c, 1Bh
		ld	a, 0Ch
		call	ovFuncExt0
		ld	hl, byte_FC3B
		call	printString4
		ld	a, 21h
		call	setBit
		ld	a, 20h
		call	setBit
		and	a
		ret

givLanternGuard:ld	c, 19h
		ld	a, 0Ch
		call	ovFuncExt0
		ld	hl, byte_F879
		call	printString4
		ld	bc, 4B0Ch
		ld	d, 0F7h
		call	sub_C246
		ld	a, 19h
		call	setBit
		and	a
		ret

givMoneyTrader:	ld	c, 7
		ld	a, 0Ch
		call	ovFuncExt0
		ld	hl, byte_F944
		call	printString4
		ld	a, 1Bh
		call	setBit
		and	a
		ret

givHairsWoman:	ld	c, 15h
		ld	a, 0Ch
		call	ovFuncExt0
		ld	hl, byte_F64D
		call	printString4
		ld	a, 15h
		call	setBit
		ld	a, 14h
		call	setBit
		and	a
		ret
		
givHeadMaster:	ld	c, 12h
		ld	a, 0Ch
		call	ovFuncExt0
		ld	hl, byte_F520
		call	printString4
		ld	a, 13h
		call	setBit
		and	a
		ret

ex1_C63F:	ld	c, 0Bh
		jr	ex1_C645
ex1_C643:	ld	c, 9
ex1_C645:	push	bc
		ld	a, 0Bh
		call	testBit
		pop	bc
		jp	z, sub_C761
		ld	a, 0Ch
		call	ovFuncExt0
		ld	a, 0Ch
		call	testBit
		push	af
		ld	a, 0Dh
		call	nz, setBit
		ld	a, 0Ch
		call	setBit
		call	sub_C761
		pop	af
		ret	z
		ld	b, 0Eh
		ld	c, 2
		ld	a, 2
		call	ovFuncExt0
		ld	a, 0Eh
		call	setBit
		and	a
		ret

ex1_C679:	ld	c, 0Ch
		ld	a, 0Ch
		call	ovFuncExt0
		ld	a, 8
		call	setBit
		ld	a, 9
		call	setBit
		jp	ex1_C7A7

givAmulWiz:	ld	c, 5
		ld	a, 0Ch
		call	ovFuncExt0
		ld	a, 22h
		call	setBit
		ld	hl, byte_EA87
		jp	printString4

ex1_C69F:	ld	a, 22h
		call	testBit
		scf
		ret	z
		ld	c, 1
		ld	a, 0Ch
		call	ovFuncExt0
		ld	a, 5
		call	setBit
		jp	ex1_C7B1

givMoneySmith:	ld	c, 7
		ld	a, 0Ch
		call	ovFuncExt0
		ld	a, 7
		call	setBit
		ld	hl, byte_EE66
		call	printString4
		ld	b, 0Ah
		ld	c, 1
		ld	a, 2
		call	ovFuncExt0
		ld	b, 0Ah
		ld	a, 9
		call	ovFuncExt0
		ld	b, 0Ah
		ld	c, 0
		ld	a, 2
		call	ovFuncExt0
		ld	c, 8
		ld	a, 0Bh
		call	ovFuncExt0
		and	a
		ret

; ----------------------
; talk with npc B

talkNpcB:	exx
		call	sub_C072
		exx
		ld	hl, talkTab
ex1_C6F1:	ld	a, (hl)
		inc	a
		scf
		ret	z
		dec	a
		cp	b
		inc	hl
		jr	z, ex1_C6FE
		inc	hl
		inc	hl
		jr	ex1_C6F1
ex1_C6FE:	ld	a, (hl)
		inc	hl
		ld	h, (hl)
		ld	l, a
		call	ext1_callHL
		and	a
		ret

; talk list : npcID, <exe.adr>

talkTab:	IDADR 1, ex1_C7B6	; DATA XREF: RAM:C6EEo
		IDADR 5, ex1_C7B1
		IDADR 8, ex1_C741
		IDADR 0Ah, ex1_C7AC
		IDADR 0Dh, ex1_C7A7
		IDADR 0Eh, sub_C761
		IDADR 10h, ex1_C73B
		IDADR 11h, ex1_C73B
		IDADR 12h, ex1_C7A2
		IDADR 15h, ex1_C79D
		IDADR 17h, ex1_C759
		IDADR 19h, ex1_C798
		IDADR 1Ah, ex1_C798
		IDADR 1Ch, ex1_C793
		IDADR 20h, ex1_C78E
		IDADR 18h, ex1_C789
		IDADR 1Bh, ex1_C784
		db 0FFh

ex1_C73B:	ld	hl, byte_F1DE
		jp	printString4

ex1_C741:	ld	hl, bitsTab
		bit	4, (hl)
		scf
		ret	nz
		set	4, (hl)
		ld	hl, byte_EC12
		call	printString4
		ld	b, 8
		ld	c, 1
		ld	a, 2
		jp	ovFuncExt0

ex1_C759:	ld	hl, byte_F6D5
		call	printString4
		jr	ex1_C77C

sub_C761:	ld	de, talkBigYuko
		call	sub_C7B9
		ld	a, 0Fh
		call	testBit
		ret	z
		ld	b, 0Fh
		ld	c, 0
		ld	a, 2
		call	ovFuncExt0
		ld	hl, byte_F157
		call	printString4
ex1_C77C:	ld	c, 1
		ld	de, 0A23h
		jp	ex1_C50D

ex1_C784:	ld	de, talkImperator
		jr	sub_C7B9

ex1_C789:	ld	de, talkMonk
		jr	sub_C7B9

ex1_C78E:	ld	de, talkHostler
		jr	sub_C7B9
		
ex1_C793:	ld	de, talkTrader
		jr	sub_C7B9

ex1_C798:	ld	de, talkGuardian
		jr	sub_C7B9

ex1_C79D:	ld	de, talkWoman
		jr	sub_C7B9

ex1_C7A2:	ld	de, talkMaster
		jr	sub_C7B9

ex1_C7A7:	ld	de, talkLittleYuko
		jr	sub_C7B9
		
ex1_C7AC:	ld	de, talkBlacksmith
		jr	sub_C7B9

ex1_C7B1:	ld	de, talkWhiteWiz
		jr	sub_C7B9

ex1_C7B6:	ld	de, talkOracle
sub_C7B9:	call	sub_C885
		jp	printString4

; talk conditions:
; bit1, bit2, <txt.adr>	: if bit1 = 0, set bit2, print <txt.adr> text
; FF,<txt.adr>		: by default

talkOracle:	DB2W 1, 1, byte_E650	; DATA XREF: RAM:ex1_C7B6o
		DB2W 2, 2, byte_E759
		IDADR 0FFh, byte_E8F1
		
talkWhiteWiz:	DB2W 2, 0, byte_E91E	; DATA XREF: RAM:ex1_C7B1o
		DB2W 3, 3, byte_E992
		DB2W 22h, 0, byte_EA3F
		DB2W 5, 0, byte_EA68
		DB2W 6, 6, byte_EAE5
		DB2W 16h, 0, byte_EB31
		DB2W 17h, 17h,	byte_EB5C
		IDADR 0FFh, byte_EB31
		
talkBlacksmith:	DB2W 7, 0, byte_EDAD	; DATA XREF: RAM:ex1_C7ACo
		IDADR 0FFh, byte_EE35
		
talkLittleYuko:	DB2W 8, 8, byte_EEA4	; DATA XREF: RAM:ex1_C7A7o
		DB2W 9, 0, byte_EF44
		DB2W 0Ah, 0Ah,	byte_EF52
		IDADR 0FFh, byte_EFF0
		
talkBigYuko:	DB2W 0Ah, 0, byte_F009 ; DATA	XREF: sub_C761o
		DB2W 0Bh, 0Bh,	byte_F03A
		DB2W 0Ch, 0, byte_F03A
		DB2W 0Dh, 0, byte_F078
		DB2W 0Eh, 0Eh,	byte_F093
		DB2W 0Fh, 0Fh,	byte_F10B
		IDADR 0FFh, byte_F13C
		
talkMaster:	DB2W 10h, 10h,	byte_F200 ; DATA XREF:	RAM:ex1_C7A2o
		DB2W 11h, 0, byte_F38C
		DB2W 12h, 12h,	byte_F3BC
		DB2W 13h, 0, byte_F4F3
		IDADR 0FFh, byte_F591
		
talkWoman:	DB2W 14h, 14h,	byte_F5AC ; DATA XREF:	RAM:ex1_C79Do
		DB2W 15h, 0, byte_F61C
		IDADR 0FFh, txt1_F690
		
talkGuardian:	DB2W 17h, 0, byte_F79E ; DATA	XREF: RAM:ex1_C798o
		DB2W 18h, 18h,	byte_F7B5
		DB2W 19h, 0, byte_F85B
		IDADR 0FFh, byte_F879
		
talkTrader:	DB2W 17h, 0, byte_F8A4 ; DATA	XREF: RAM:ex1_C793o
		DB2W 1Ah, 1Ah,	byte_F8C0
		DB2W 1Bh, 0, txt1_F903
		IDADR 0FFh, byte_F928
		
talkHostler:	DB2W 17h, 0, byte_F97A ; DATA	XREF: RAM:ex1_C78Eo
		DB2W 1Ch, 1Ch,	byte_F996
		DB2W 1Dh, 0, byte_F9C6
		DB2W 1Eh, 1Eh,	byte_F9E9
		IDADR 0FFh, byte_FA18
		
talkMonk:	DB2W 17h, 0, byte_FA2E ; DATA	XREF: RAM:ex1_C789o
		DB2W 1Fh, 1Fh,	byte_FA48
		IDADR 0FFh, byte_FAA0
		
talkImperator:	DB2W 20h, 20h,	byte_FB81 ; DATA XREF:	RAM:ex1_C784o
		DB2W 21h, 0, byte_FC1D
		IDADR 0FFh, byte_FC6B

; test bit A: Z/NZ

testBit:	call	getBitAdr
		ld	a, (hl)
		and	c
		ret

sub_C885:	ld	a, (de)
		inc	de
		cp	0FFh
		jr	z, ex1_C89A
		call	testBit
		jr	z, ex1_C895
		inc	de
		inc	de
		inc	de
		jr	sub_C885
ex1_C895:	ld	a, (de)
		inc	de
		call	setBit
ex1_C89A:	ex	de, hl
		ld	a, (hl)
		inc	hl
		ld	h, (hl)
		ld	l, a
		ret

; set bit A

setBit:		call	getBitAdr
		ld	a, (hl)
		or	c
		ld	(hl), a
		ret

; HL,C = adr,mask of bit A

getBitAdr:	ld	c, a
		rra
		rra
		rra
		and	1Fh
		ld	hl, bitsTab
		add	a, l
		ld	l, a
		jr	nc, ex1_C8B5
		inc	h
ex1_C8B5:	ld	a, c
		ld	c, 1
		and	7
		ret	z
ex1_C8BB:	rlc	c
		dec	a
		jr	nz, ex1_C8BB
		ret

; ---------------------------------------------------------------------------
; gameover / final

finalStringTab:	dw asc_FC95
		dw asc_FD34
		dw asc_FDC1
		dw asc_FE46
		dw byte_FF3C
		
; go ext3.func1 : play finalcut

ex1_C8CB:	ld	a, 1
		jp	ovFuncExt3

; print final string C

prnFinalString:	ld	hl, finalStringTab
		ld	b, 0
		add	hl, bc
		add	hl, bc
		ld	a, (hl)
		inc	hl
		ld	h, (hl)
		ld	l, a
printString4:	ld	de, 1012h	; print string from HL
ex1_C8DE:	ld	(prnCoord+1), de
ex1_C8E2:	ld	a, (hl)
		and	a
		jp	z, extTxt00
		inc	hl
		cp	1
		jp	z, extTxt01
		cp	2
		jp	z, extTxt02
		cp	3
		jp	z, extTxt03
		cp	4
		jp	z, extTxt04
		cp	5
		jp	z, extTxt05
		cp	6
		jr	z, extTxt06
		cp	7
		jr	z, extTxt07
		cp	8
		jr	z, extTxt08
		cp	9
		jr	z, extTxt09
		cp	0Dh
		jp	z, extTxt0D
		cp	20h
		call	nc, printChar4
		jr	ex1_C8E2

; 9,n		out avatar N

extTxt09:	ld	a, (hl)
		inc	hl
		push	hl
		push	de
		ld	hl, avatarData
		ld	de, 0A0h
		call	addDEmulA
		ld	de, 5042h
		ld	bc, 5FFh
ex1_C930:	ld	a, e
		ldi
		ldi
		ldi
		ldi
		ld	e, a
		inc	d
		ld	a, d
		and	7
		jr	nz, ex1_C930
		ld	a, e
		add	a, 20h
		ld	e, a
		jr	c, ex1_C94A
		ld	a, d
		sub	8
		ld	d, a
ex1_C94A:	djnz	ex1_C930
		pop	de
		pop	hl
		jp	ex1_C8E2

;8, n		add N exp

extTxt08:	ld	a, (hl)
		inc	hl
		push	de
		push	hl
		ld	d, a
		ld	a, 0Eh
		call	ovEngineFunc
		pop	hl
		pop	de
		jp	ex1_C8E2

; 7,<adr>	call adr

extTxt07:	ld	c, (hl)
		inc	hl
		ld	b, (hl)
		inc	hl
		push	hl
		push	de
		ld	h, b
		ld	l, c
		call	ext1_callHL
		pop	de
		pop	hl
		jp	ex1_C8DE

; 4, id		remove item ID from bag

extTxt04:	ld	c, (hl)
		inc	hl
		push	hl
		push	de
		ld	a, 0Ch
		call	ovFuncExt0
		pop	de
		pop	hl
		jp	ex1_C8E2

; 5		fill map black

extTxt05:	ld	c, 40h
		jr	ex1_C984
		
; 6		fill map default color

extTxt06:	ld	c, 0
ex1_C984:	ld	a, 0Ch
		push	hl
		push	de
		call	ovEngineFunc
		pop	de
		pop	hl
		jp	ex1_C8DE

; 1		clear message window

extTxt01:	call	clrMsgWindow
		jp	ex1_C8DE
		
; 3,n		set current spell

extTxt03:				; CODE XREF: printString4+19j
		ld	a, (hl)
		inc	hl
		ld	(spellsCnt), a
		ld	(curSpell), a
		push	hl
		push	de
		call	drawSpells
		pop	de
		pop	hl
		jp	ex1_C8DE
		
; 2,id		put item ID in bag

extTxt02:				; CODE XREF: printString4+14j
		ld	c, (hl)
		inc	hl
		push	hl
		push	de
		ld	a, 0Bh
		call	ovFuncExt0
		pop	de
		pop	hl
		jp	ex1_C8DE
		
; 0d		CR+LF

extTxt0D:	inc	e
		ld	a, e
		cp	17h
		jp	c, ex1_C8DE
		call	clrMsgWindow
		jp	ex1_C8DE
		
; 00		end. clear whole window
		
extTxt00:	ld	hl, 5041h
		ld	bc, 51Eh
		jr	ex1_C9DB

; wait key & clear text window

clrMsgWindow:	call	fNoKey
		call	fWaitKey
		call	fNoKey
		exx
		ld	hl, 5046h
		ld	bc, 519h
ex1_C9DB:	ld	d, l
		ld	e, c
		xor	a
ex1_C9DE:	ld	(hl), a
		inc	l
		dec	e
		jr	nz, ex1_C9DE
		ld	l, d
		inc	h
		ld	a, h
		and	7
		jr	nz, ex1_C9DB
		ld	a, l
		add	a, 20h
		ld	l, a
		ld	a, h
		sub	8
		ld	h, a
		djnz	ex1_C9DB
		exx
		ld	de, 1012h
		ret
		
; print char A
		
		xor	a
printChar4:	push	bc
		push	de
		push	hl
		ld	l, a
		ld	h, 0
		ld	de, font4
		add	hl, de
prnCoord:	ld	bc, 0
		srl	b
		push	af
		ld	a, c
		rrca
		rrca
		rrca
		and	0E0h
		or	b
		ld	e, a
		ld	a, c
		and	18h
		or	41h
		ld	d, a
		pop	af
		ld	bc, 60Fh
		jr	nc, ex1_CA20
		ld	c, 0F0h
ex1_CA20:	ld	a, (de)
		and	c
		ld	(de), a
		ld	a, c
		cpl
		and	(hl)
		ex	de, hl
		or	(hl)
		ld	(hl), a
		ex	de, hl
		inc	h
		inc	d
		djnz	ex1_CA20
		ld	hl,  prnCoord+2
		inc	(hl)
		pop	hl
		pop	de
		pop	bc
		ret

; draw spell icons

drawSpells:	ld	a, 3		; remove arrow
		call	ovEngineFunc
		ld	de, 40F3h
		ld	b, 1
		call	loc_D058
		ld	de, 40F6h
		ld	b, 2
		call	loc_D058
		ld	de, 40F9h
		ld	b, 3
		call	loc_D058
		ld	a, 2
		ret

		dw 0		; wtf is it?

loc_D058:	ld	a, (spellsCnt)
		cp	b
		ld	hl, 0FF00h
		ld	c, 0
		jr	c, loc_D06D
		ld	c, b
		ld	a, (curSpell)
		cp	b
		jr	z, loc_D06D
		ld	hl, 0AAFFh
loc_D06D:	ld	a, h
		ld	(loc_D08A+1), a
		ld	a, l
		ld	(loc_D098+1), a
		ld	l, c
		ld	h, 0
		add	hl, hl
		add	hl, hl
		add	hl, hl
		ld	c, l
		ld	b, h
		add	hl, hl
		add	hl, hl
		add	hl, hl
		add	hl, bc
		ld	bc, spellIcons
		add	hl, bc
		ld	b, 3
loc_D087:	ld	c, 3
loc_D089:	ld	a, (hl)
loc_D08A:	and	0
		ld	(de), a
		inc	hl
		inc	e
		dec	c
		jr	nz, loc_D089
		dec	e
		dec	e
		dec	e
		ld	a, (loc_D08A+1)
loc_D098:	xor	0
		ld	(loc_D08A+1), a
		inc	d
		ld	a, d
		and	7
		jr	nz, loc_D087
		ld	a, e
		add	a, 20h
		ld	e, a
		jr	c, loc_D0AD
		ld	a, d
		sub	8
		ld	d, a
loc_D0AD:	djnz	loc_D087
		ret
; ---------------------------------------------------------------------------

spellIcons:	incbin "spells.bin"

bitsTab:	db 0, 0, 0, 0, 0, 0, 0,	0

; ---------------------------------------------------------------------------
; fight
; L : enemy agression

doBattle:	ld	a, h
		ld	(enmStrength+1), a
		ld	a, l
		ld	(enmAgression+1), a
		ld	d, 0
		ld	hl, battleIconTab
		add	hl, de
		add	hl, de
		add	hl, de
		ld	a, (hl)
		ld	(enemyId+1), a
		inc	hl
		ld	a, (hl)
		inc	hl
		ld	h, (hl)
		ld	l, a
		ld	(enmSprAdr+1), hl
		ld	c, 8		; check item 8 (shield)
		ld	a, 0Eh
		call	ovFuncExt0
		ld	a, 37h
		jr	nz, loc_D201
		ld	a, 0A7h
loc_D201:	ld	(shieldFlag), a
		call	sub_D2BD
		ld	a, (enemyId)
		ld	b, a
		ld	a, 11h
		call	ovEngineFunc
		xor	a
		ld	hl, vikFightSpr3
		ld	de, 5041h
		call	drawFightSpr
loc_D21A:	xor	a
enmSprAdr:	ld	hl, 0
		ld	de, 504Ah
		call	drawFightSpr
loc_D224:	halt
		halt
		halt
		halt
loc_D228:	and	a
		jr	c, loc_D23A
		xor	a
		in	a, (0FEh)
		cpl
		and	1Fh
		jr	z, loc_D258
		ld	a, 37h
		ld	(loc_D228), a
		jr	loc_D292
loc_D23A:	xor	a
		ld	hl, vikFightSpr3
		ld	de, 5041h
		call	drawFightSpr
		xor	a
		in	a, (0FEh)
		cpl
		and	1Fh
		jr	nz, loc_D258
		ld	a, 0A7h
		ld	(loc_D228), a
;		jr	loc_D258		
;		ld	a, 0A7h			; ???
;		ld	(loc_D228), a
loc_D258:	call	extRandom
enmAgression:	cp	0
		jr	c, loc_D224
		ld	a, 1			; enemy attacks
		ld	hl, (enmSprAdr+1)
		ld	de, 504Ah
		call	drawFightSpr
enmStrength:	ld	d, 0
shieldFlag:	scf
		jr	c, loc_D271
		srl	d
loc_D271:	ld	a, 0Fh			; sub D HP
		call	ovEngineFunc
		cp	2
		jr	c, loc_D282
		ld	b, 0Ah
loc_D27C:	halt
		djnz	loc_D27C
		jp	loc_D21A
loc_D282:	call	clrWindow
		ld	a, 5			; game over 1
		ld	c, 1
		jp	ovEngineFunc

; HL += DE * A

addDEmulA:	inc	a
loc_D28D:	dec	a
		ret	z
		add	hl, de
		jr	loc_D28D

loc_D292:	ld	a, 1			; hero attacks
		ld	hl, vikFightSpr3
		ld	de, 5041h
		call	drawFightSpr
		ld	a, 37h
		ld	(loc_D228), a
		halt
		halt
		halt
enemyId:	ld	b, 0
		ld	a, 10h
		call	ovEngineFunc
		cp	2
		jp	nc, loc_D224
clrWindow:	ld	hl, 5041h	; clear whole window
		ld	bc, 51Eh
		call	ex1_C9DB
		jp	sub_C072

; ? copy HP bar to battle panel (for hero & for enemy)

sub_D2BD:	ld	hl, 4892h
		ld	de, 5046h
		call	sub_D2CC
		ld	hl, 4892h
		ld	de, 5048h
sub_D2CC:	ld	b, 5
loc_D2CE:	ld	a, (hl)
		ld	(de), a
		inc	d
		inc	h
		ld	a, h
		and	7
		jr	nz, loc_D2CE
		ld	a, l
		add	a, 20h
		ld	l, a
		jr	c, loc_D2E1
		ld	a, h
		sub	8
		ld	h, a
loc_D2E1:	ld	a, e
		add	a, 20h
		ld	e, a
		jr	c, loc_D2EB
		ld	a, d
		sub	8
		ld	d, a
loc_D2EB:	djnz	loc_D2CE
		ret
		
; A = rnd

extRandom:	push	hl
extRndAdr:	ld	hl, 0FFFFh
		inc	hl
		ld	a, h
		and	3Fh
		ld	(extRndAdr+1), hl
		ld	a, r
		xor	(hl)
		pop	hl
		ret

; fill message window atrs by table HL

msgWindowAtrs:	ld	de, 5A41h
		ld	b, 5
loc_D303:	push	hl
loc_D304:	ld	a, (hl)
		and	a
		jr	z, loc_D313
		ld	c, a
		inc	hl
		ld	a, (hl)
		inc	hl
loc_D30C:	ld	(de), a
		inc	de
		dec	c
		jr	nz, loc_D30C
		jr	loc_D304
loc_D313:	inc	de
		inc	de
		pop	hl
		djnz	loc_D303
		ret

drawFightSpr:	push	de
		ld	de, 0C8h
		call	addDEmulA
		pop	de
		ld	bc, 5FFh
loc_D324:	ld	a, e
		ldi
		ldi
		ldi
		ldi
		ldi
		ld	e, a
		inc	d
		ld	a, d
		and	7
		jr	nz, loc_D324
		ld	a, e
		add	a, 20h
		ld	e, a
		jr	c, loc_D340
		ld	a, d
		sub	8
		ld	d, a
loc_D340:	djnz	loc_D324
		ret

; battles: npcId, <sprites.adr>

battleIconTab:	IDADR 0Bh, byte_D5A4	; DATA XREF: RAM:D1E2o
		IDADR 0Ch, byte_D734
		IDADR 13h, byte_D8C4
		
vikFightSpr3:	incbin "fightspr00.bin"
byte_D5A4:	incbin "fightspr01.bin"
byte_D734:	incbin "fightspr02.bin"
byte_D8C4:	incbin "fightspr03.bin"

; ---------------------------------------------------------------------------
; final fight

loc_DA54:	ld	c, 1		; fill map atr 1
		ld	a, 0Ch
		call	ovEngineFunc
loc_DA5B:	ld	a, 0Ah
		ld	(loc_DA6D+1), a
loc_DA60:	ld	a, 96h
		call	scanKeys
loc_DA65:	scf
		ld	a, 0A7h
		ld	(loc_DA65), a
		jr	c, loc_DA60
loc_DA6D:	ld	a, 0
		dec	a
		jp	z, wizLight
		ld	(loc_DA6D+1), a
		ld	b, 0
		ld	a, 6
		call	ovFuncExt0
		inc	h
		jr	nz, loc_DA8B
		ld	a, b
		cp	d
		jr	nz, loc_DA8B
		call	extRandom
		rra
		jr	c, loc_DA8B
		ld	c, e
loc_DA8B:	push	bc
		ld	b, 41h
		call	fillCellAtr
		ld	b, 1		; set npc 1 anim 3
		ld	c, 3
		ld	a, 2
		call	ovFuncExt0
		ld	a, 32h
		call	scanKeys
		pop	bc
		push	bc
		ld	b, 1
		call	fillCellAtr
		pop	bc
		ld	b, 64h
		ld	a, 7
		call	ovEngineFunc
		inc	d
		jr	z, finDeath
		ld	h, b
		ld	l, c
		ld	de, 0
		ld	b, 2Ch
		ld	a, 11h
		call	ovFuncExt0
		jr	loc_DA60

; hero is dead

finDeath:	ld	b, 0		; set hero ani 6
		ld	c, 6
		ld	a, 2
		call	ovFuncExt0
		ld	c, 2		; fill map atr 2
		ld	a, 0Ch
		call	ovEngineFunc
		ld	b, 26h
		call	sub_DB46
		ld	b, 27h
		call	sub_DB46
		ld	b, 28h
		call	sub_DB46
		ld	b, 29h
		call	sub_DB46
		ld	b, 2Ah
		call	sub_DB46
		ld	b, 2Bh
		call	sub_DB46
		ld	b, 96h
loc_DAEF:	halt
		djnz	loc_DAEF
		ld	a, 5		; game over 2
		ld	c, 2
		jp	ovEngineFunc
		
; evil wizard light a candle (all -> game over)
		
wizLight:	ld	b, 1		; set npc 1 ani 4
		ld	c, 4
		ld	a, 2
		call	ovFuncExt0
		ld	b, 26h
		call	lightCandle
		jp	nc, loc_DA5B
		ld	b, 27h
		call	lightCandle
		jp	nc, loc_DA5B
		ld	b, 28h
		call	lightCandle
		jp	nc, loc_DA5B
		ld	b, 29h
		call	lightCandle
		jp	nc, loc_DA5B
		ld	b, 2Ah
		call	lightCandle
		jp	nc, loc_DA5B
		ld	b, 2Bh		; set npc 0x2b ani 0
		ld	c, 0
		ld	a, 2
		call	ovFuncExt0
		ld	c, 2		; fill map atr 2
		ld	a, 0Ch
		call	ovEngineFunc
		ld	b, 32h
loc_DB3C:	halt
		djnz	loc_DB3C
		ld	a, 5		; game over 3
		ld	c, 3
		jp	ovEngineFunc

; evil wiz lights candle B (npcID)
		
sub_DB46:	call	lightCandle
		ret	c
		ld	b, 1		; set npc 1 ani 4
		ld	c, 4
		ld	a, 2
		call	ovFuncExt0
		ld	b, 1		; wait npc 1
		ld	a, 9
		jp	ovFuncExt0

; try to light candle B (npcID)
; out	CY=1: already lights

lightCandle:	ld	a, 7		; C = anim of npc B
		call	ovFuncExt0
		inc	c
		scf
		ret	nz
		ld	c, 0		; set anim 0 : candle lights (loop animation)
		ld	a, 2
		call	ovFuncExt0
		and	a
		ret

; fill 2x2 cell on crd C with atr B

fillCellAtr:	ld	hl, 5821h
		ld	a, c
		rra
		rra
		rra
		and	7
		ld	de, 40h
		jr	z, loc_DB7D
loc_DB79:	add	hl, de
		dec	a
		jr	nz, loc_DB79
loc_DB7D:	ld	a, c
		and	7
		add	a, a
		ld	e, a
		add	hl, de
		ld	e, 1Fh
		ld	(hl), b
		inc	l
		ld	(hl), b
		add	hl, de
		ld	(hl), b
		inc	l
		ld	(hl), b
		ret

scanKeys:	ld	(loc_DBAD+1), a
		ld	a, 0A7h
		ld	(loc_61CE), a
		halt
		ld	hl, keyJumpTab
loc_DB99:	ld	a, (hl)
		and	a
		jr	z, loc_DBAD
		inc	hl
		in	a, (0FEh)
		and	(hl)
		inc	hl
		jr	z, jpPeekHL
		inc	hl
		inc	hl
		jr	loc_DB99
jpPeekHL:	ld	a, (hl)		; ld hl,(hl); jp (hl)
		inc	hl
		ld	h, (hl)
		ld	l, a
		jp	(hl)
loc_DBAD:	ld	a, 0
		dec	a
		jr	nz, scanKeys
		ret

; portHi, mask, <exe.adr>

keyJumpTab:	DB2W 0FBh, 1, fmovUp
		DB2W 0EFh, 8, fmovUp
		DB2W 0FDh, 1, fmovDown
		DB2W 0EFh, 10h, fmovDown
		DB2W 0DFh, 2, fmovLeft
		DB2W 0F7h, 10h, fmovLeft
		DB2W 0DFh, 1, fmovRight
		DB2W 0EFh, 4, fmovRight
		DB2W 7Fh, 1, loc_DC4F
		DB2W 0F7h, 1, setSpell1
		DB2W 0F7h, 2, setSpell2
		DB2W 0F7h, 4, setSpell3
		db 0
; 
; 1,2,3		select spell

setSpell1:	ld	b, 1
		jr	loc_DBEE
setSpell2:	ld	b, 2
		jr	loc_DBEE
setSpell3:	ld	b, 3
loc_DBEE:	ld	hl, curSpell
		ld	a, (hl)
		cp	b
		jp	z, loc_DBAD
		ld	(hl), b
		ld	a, 2			; call drawSpells ?
		call	ovFuncExt1
		ld	a, 3			; arrow off
		call	ovEngineFunc
		jp	loc_DBAD

; move keys

fmovUp:		ld	h, 1
		jr	loc_DC12
fmovDown:	ld	h, 0
		jr	loc_DC12
fmovLeft:	ld	h, 2
		jr	loc_DC12
fmovRight:	ld	h, 3
loc_DC12:	ld	b, 0
		ld	a, 8
		call	ovFuncExt0
		ld	a, c
		cp	h
		jr	z, loc_DC31
		ld	c, h
		ld	a, 3
		call	ovFuncExt0
		ld	b, 0Ah
loc_DC25:	halt
		djnz	loc_DC25
		ld	a, (loc_DBAD+1)
		sub	0Ah
		jp	nc, scanKeys
		ret

loc_DC31:	ld	a, 2		; set anim (0..3 - move to dir)
		call	ovFuncExt0
loc_DC36:	halt
		ld	b, 0
		ld	a, 7
		call	ovFuncExt0
		inc	c
		jp	z, loc_DBAD
		ld	hl,  loc_DBAD+1
		dec	(hl)
		jr	nz, loc_DC36
		ld	b, 0		; wait hero
		ld	a, 9
		jp	ovFuncExt0

loc_DC4F:	ld	b, 0		; get ahead
		ld	a, 6
		call	ovFuncExt0
		ld	a, h		; is evil wiz?
		cp	1
		jp	nz, loc_DBAD
		ld	b, h		; set wiz anim (curSpell + 4)
		ld	a, (curSpell)
		add	a, 4
		ld	c, a
		ld	a, 2
		call	ovFuncExt0
		ld	a, (curSpell)
		dec	a
		jr	z, loc_DC85
		dec	a
		jr	z, loc_DC7B
		ld	a, 37h
		ld	(loc_DA65), a
		ld	e, 6
		and	a
		jr	loc_DC88
loc_DC7B:	ld	a, 0A7h
		ld	(loc_DA65), a
		ld	e, 5
		and	a
		jr	loc_DC88
loc_DC85:	ld	e, 3
		scf
loc_DC88:	push	af
		push	de
		ld	a, 0Eh
		ld	d, 0
		call	ovEngineFunc
		rra
		rra
		rra
		rra
		and	0Fh
		pop	de
		ld	d, 0
loc_DC9A:	inc	d
		sub	e
		jr	nc, loc_DC9A
loc_DC9E:	xor	a
		in	a, (0FEh)
		cpl
		and	1Fh
		jr	nz, loc_DC9E
		push	de
		ld	c, 2		; fill map atr 2
		ld	a, 0Ch
		call	ovEngineFunc
		ld	b, 1		; wait npc 1
		ld	a, 9
		call	ovFuncExt0
		ld	a, 15h		; ? lose all strength
		call	ovFuncExt0
		ld	c, 1		; fill map atr 1
		ld	a, 0Ch
		call	ovEngineFunc
		pop	de		; sub D hp of npc 1
		ld	b, 1
		ld	a, 14h
		call	ovFuncExt0
		cp	2
		jr	c, victory
		pop	af
		jp	c, wizLight
		jp	loc_DA60

victory:	ld	a, 37h
		ld	(loc_61CE), a
		ld	b, 1		; set npc 1 anim 1
		ld	c, 1
		ld	a, 2
		call	ovFuncExt0
		ld	b, 1		; wait npc 1
		ld	a, 9
		call	ovFuncExt0
		ld	a, 5		; game over 4 (win, finalcut)
		ld	c, 4
		jp	ovEngineFunc
		
; ---------------------------------------------------------------------------

avatarData:	incbin "avatars.bin"
font4:		incbin "font46.bin"
		
byte_E650:	db 9, 0
		db " , . , , ?",13
		db "  .  ,  ",13
		db "   ,   ..."
		db 1
		db "   ,    ,",13
		db " .   ,   ",13
		db " .   ,   ..."
		db 1, 0
byte_E759:	db 9, 0
		db "  -    ",13
		db "     ,",13
		db "     .",13
		db "      "
		db 1
		db "     ",13
		db ".   ,   ",13
		db "      ",13
		db "..."
		db 1
		db "    . , ",13
		db "     ...",13
		db " , "
		db 1, 8, 3, 0
byte_E8F1:	db 9, 0
		db ",     !!!"
		db 1, 0
byte_E91E:	db 9, 1
		db "  ...     ",13
		db " ,    .   ",13
		db ",   "
		db 1, 0
byte_E992:	db 9, 1
		db "  ?..   - ",13
		db " .   ,     ",13
		db "   .  ,  ",13
		db " ,   "
		db 1, 2, 1, 8, 1, 0
byte_EA3F:	db 9, 1
		db "    ...   ?"
		db 1, 0
byte_EA68:	db 9, 1
		db "  , !"
		db 1, 0
byte_EA87:	db 9, 1
		db "  !     ",13
		db "  ...",13
		db "  -  !"
		db 1, 0
byte_EAE5:	db 9, 1
		db "  ,  ",13
		db ".      "
		db 1, 2, 6, 8, 3, 0
byte_EB31:	db 9, 1
		db "   ,    ..."
		db 1, 0
byte_EB5C:	db 9, 1
		db "   -  - ",13
		db "   ,   ...  ",13
		db " , ,     .  ",13
		db "  ,    ..."
		db 1, 8, 2, 0
byte_EC12:	db 9, 2
		db "     , ?",13
		db "    ,   ?",13
		db "  ,     ,  ",13
		db "  ,  ."
		db 1
		db "     ,   ",13
		db ",     . ",13
		db "      ,  ",13
		db " ."
		db 1
		db "    .",13
		db ", ,   -   ",13
		db " "
		db 1, 3, 1, 8, 4, 0
byte_EDAD:	db 9, 3
		db " ,  .    ",13
		db "   ,    ",13
		db "...      "
		db 1, 0
byte_EE35:	db 9, 3
		db "! ,  !   - "
		db 1, 0
byte_EE66:	db 9, 3
		db " -  ...   .",13
		db " "
		db 1, 8, 3, 0
byte_EEA4:	db 9, 4
		db ", , ?    .  ",13
		db "    ."
		db 1
		db " ,   ?   ",13
		db "       "
		db 1, 0
byte_EF44:	db 9, 4
		db " ?"
		db 1, 0
byte_EF52:	db 9, 4
		db ".    , ",13
		db "      .  ",13
		db "  -  .  ",13
		db ", "
		db 1, 2, 0Ah, 2, 7, 8, 3, 0
byte_EFF0:	db 9, 4
		db "   "
		db 1, 0
byte_F009:	db 9, 4
		db "  ,      "
		db 1, 0
byte_F03A:	db 9, 4
		db "     .  - ",13
		db " "
		db 1, 0
byte_F078:	db 9, 4
		db "   ..."
		db 1, 0
byte_F093:	db 9, 4
		db ", ...    ",13
		db " .    ",13
		db " ,   ."
		db 1, 8, 2, 0
byte_F10B:	db 9, 4
		db "        !"
		db 1, 0
byte_F13C:	db 9, 4
		db ", ..."
		db 1, 0
byte_F157:	db 9, 5
		db " ,  ...     ",13
		db ", .      ",13
		db " ,     ..."
		db 1, 2, 0Dh, 3, 2, 0
byte_F1DE:	db 9, 7
		db "    "
		db 1, 0
byte_F200:	db 9, 6
		db "  , ?   ",13
		db " ,      - ",13
		db "      .",13
		db "   ,   ",13
		db "    "
		db 1
		db "   ,  ,  ",13
		db "    -   ",13
		db "  ,   . ",13
		db "   ,    "
		db 1, 0
byte_F38C:	db 9, 6
		db "      , ..."
		db 1, 0
byte_F3BC:	db 9, 6
		db ",    ...  ",13
		db ", ..."
		db 1, 5
		db "-     ",13
		db "   . ",13
		db "     ..."
		db 1
		db "     ..."
		db 1
		db "    ,  ",13
		db ".   ..."
		db 1, 7
		dw ex1_C02E
		db 6, 0
byte_F4F3:	db 9, 6
		db " ...    !"
		db 1, 0
byte_F520:	db 9, 6
		db "-, !  ,  ,",13
		db "    !",13
		db "   . "
		db 1, 2, 13h, 8, 2, 0
byte_F591:	db 9, 6
		db " ..."
		db 1, 0
byte_F5AC:	db 9, 8
		db "    ?  ",13
		db "  ...    .",13
		db " , ."
		db 1, 0
byte_F61C:	db 9, 8
		db "  ,    !"
		db 1, 0
byte_F64D:	db 9, 8
		db "   .  ",13
		db " ..."
		db 1, 2, 16h, 8, 2, 0
txt1_F690:	db 9, 8
		db ",    ,   ",13
		db "  ?.."
		db 1, 0
byte_F6D5:	db 9, 9
		db ", .  ,   .",13
		db "   ,    ",13
		db " .   ,   ",13
		db " ,     - ",13
		db " ..."
		db 1, 2, 17h, 0
byte_F79E:	db 9, 0Ch
		db "    "
		db 1, 0
byte_F7B5:	db 9, 0Ch
		db "    -    ",13
		db " .    , ",13
		db " -   !"
		db 1, 0
		db "     "
		db 1, 0
byte_F85B:	db 9, 0Ch
		db "  - ..."
		db 1, 0
byte_F879:	db 9, 0Ch
		db "     ..."
		db 1, 0
byte_F8A4:	db 9, 0Ah
		db "     ..."
		db 1, 0
byte_F8C0:	db 9, 0Ah
		db "    ,    ",13
		db "  "
		db 1, 2, 18h, 0
txt1_F903:	db 9, 0Ah
		db "  -   "
		db 1, 0
byte_F928:	db 9, 0Ah
		db ", ..."
		db 1, 0
byte_F944:	db 9, 0Ah
		db ",  !   ,   "
		db 1, 2, 19h, 8, 2, 0
byte_F97A:	db 9, 0Bh
		db "     ..."
		db 1, 0
byte_F996:	db 9, 0Bh
		db ",    ,   !"
		db 1, 0
byte_F9C6:	db 9, 0Bh
		db "  -  "
		db 1, 0
byte_F9E9:	db 9, 0Bh
		db "!     ,  ..."
		db 1, 2, 7, 8, 3, 0
byte_FA18:	db 9, 0Bh
		db ", ..."
		db 1, 0
byte_FA2E:	db 9, 0Eh
		db "    ..."
		db 1, 0
byte_FA48:	db 9, 0Eh
		db "    .   , ",13
		db "     ."
		db 1, 0
byte_FAA0:	db 9, 0Eh
		db "  -  "
		db 1, 0
txt1_FAC5:	db 9, 0Eh
		db "   , ,   ",13
		db "  ...      ",13
		db "   "
		db 1, 2, 1Dh, 3, 3
		db "      !"
		db 1, 0
asc_FB60:	db "     ..."
		db 1, 0
byte_FB81:	db 9, 0Dh
		db "  . ,    ",13
		db " -     . ",13
		db "  ,    ",13
		db " ..."
		db 1, 0
byte_FC1D:	db 9, 0Dh
		db "  , "
		db 1, 0
byte_FC3B:	db 9, 0Dh
		db " , ...  "
		db 1, 2, 1Ch, 8, 5, 0
byte_FC6B:	db 9, 0Dh
		db "      "
		db 1, 0
asc_FC95:	db "    .   ",13
		db "   . -  .",13
		db " ,   . - ",13
		db "  ..."
		db 1, 0
asc_FD34:	db "      .  ",13 ; DATA XREF: RAM:C8C3o
		db " .     ",13
		db "  .",13
		db "              ~ ...~"
		db 1, 0
asc_FDC1:	db "  ,     ",13
		db " . ~   ",13
		db "~ -  .   - ..."
		db 1, 0
asc_FE46:	db "   .  ",13
		db "   .   ",13
		db "  ,    ",13
		db ". ~    ~ - ",13
		db "   - ~ !!!~"
		db 1
		db "     ..."
		db 1, 0
byte_FF3C:	db 0Dh,	0Dh
		db "          ..."
		db 1, 7
		dw ex1_C8CB
		db 0
