; ---------------------------------------------------------------------------
; Viking Quest 2
; disassebled by IDA pro
; Processor	  : z80	[]
; Target assembler: Zilog Macro	Assembler

	DEVICE ZXSPECTRUM128
	ENCODING DOS

	MACRO IDADR id,adr
	 db id
	 dw adr
	ENDM

	org 0xc000,0
	include "block00.asm"
	display "block00\t0xc000,",$-0xc000
	savebin "obj/page0.bin",0xc000,$-0xc000
	
	org 0xc000,1
	include "block01.asm"
	display "block01\t0xc000,",$-0xc000
	savebin "obj/page1.bin",0xc000,$-0xc000
	
	org 0xc000,3
	include "block03.asm"
	display "block03\t0xc000,",$-0xc000
	savebin "obj/page3.bin",0xc000,$-0xc000

	org 0xc000,4
	include "pt3xplayer.asm"
muzFAdr	dw muzFree
muzTab	dw muz0p,muz1p,muz2p,muz3p
	dw muz4p,muz5p,muz6p
muz0p	incbin "pakmuz/muz0.pak"
muz1p	incbin "pakmuz/muz1.pak"
muz2p	incbin "pakmuz/muz2.pak"
muz3p	incbin "pakmuz/muz3.pak"
muz4p	incbin "pakmuz/muz4.pak"
muz5p	incbin "pakmuz/muz5.pak"
muz6p	incbin "pakmuz/muz6.pak"
muzFree	equ $
	display "block04\t0xc000,",$-0xc000
	savebin "obj/page4.bin",0xc000,$-0xc000

	org 0xc000,6
	incbin "map.bin"
	display "block06\t0xc000,",$-0xc000
	savebin "obj/page6.bin",0xc000,$-0xc000


	org 0x6161,0
spnt	equ $
		jp	intHandle
begin		jp	startPoint		; process starts here
ovEngineFunc:	jp	callEngineFunc
ovFuncExt0:	jp	callExt0
ovFuncExt1:	jp	callExt1
ovFuncExt3:	jp	callExt3
fatalErr:	jp	exitGame
fWaitKey:	jp	waitKey
fNoKey:		jp	noKey
fNoFire:	jp	noFire
fBackupScr:	jp	backupScr

heroId:	db 0
curMapNr:	db 0
curBank:	db 0
curMapAdr:	dw 0
curItem:	db 0
curSpell:	db 0
spellsCnt:	db 0

fArrOn:		jp	arrOn
fArrOff:	jp	arrOff

arrKeys:	db 0
arrDState:	db 0

; ---------------------------------------------------------------------------

intHandle:	push	af
		push	bc
		push	de
		push	hl
		ex	af, af'
		exx
		push	af
		push	bc
		push	de
		push	hl
		push	ix
		push	iy
		ld	a, (curBank)
		push	af
		
arrowFlag:	scf
		jr	c, flashFlag
		call	movArrow
		ld	a, c
		ld	(arrKeys), a
		
flashFlag:	scf
		jr	c, aniFlag
		ld	a, (curBank)
		ld	hl,  loc_67C3+1
		and	7
		or	(hl)
		ld	bc, 0x7FFD
		out	(c), a
		ld	a, (hl)
		xor	8
		ld	(hl), a
		
aniFlag:	scf
		ld	a, 1
		call	nc, ovFuncExt0
		
loc_61C9:	ld	a, 64h
		dec	a
		jr	nz, loc_61D6
loc_61CE:	scf
		ld	a, 13h
		call	nc, ovFuncExt0
		ld	a, 64h
loc_61D6:	ld	(loc_61C9+1), a

muzFlag:	scf
		ld	a, 13h
		call	nc, ovEngineFunc
		
		pop	af
		call	setBank
		pop	iy
		pop	ix
		pop	hl
		pop	de
		pop	bc
		pop	af
		exx
		ex	af, af'
		pop	hl
		pop	de
		pop	bc
		pop	af
		ei
		ret

arrOff:		ld	a, (rmArrow)
		ld	(arrDState), a
		ld	a, 37h
		ld	(arrowFlag), a
		jp	rmArrow
		
arrOn:		call	noMove
		call	drawArrow
		ld	a, 0A7h
		ld	(arrowFlag), a
		ret

getArrowKPos:	halt
		ld	a, (arrKeys)
		and	10h
		ld	hl, (arrowXY+1)
		ret	z
		scf
		ret

; on/off 5/7 screens flashing
flashOn:	ld	a, 0A7h
		jr	loc_621F
flashOff:	ld	a, 37h
loc_621F:	ld	(flashFlag), a
		cp	0A7h
		ret	z
		ld	a, 10h
		ld	(loc_67C3+1), a
		ld	a, (curBank)
		jp	setBank

; on/off npc animation
aniOn:		ld	a, 0A7h
		jr	loc_6236
aniOff:		ld	a, 37h
loc_6236:	ld	(aniFlag), a
		ret

; start of game : go menu
startPoint:	xor	a
		jp	ovFuncExt3
	
; call engine func A
callFunc:	cp	engFuncMax
		ret	nc
		push	hl
		ld	hl, funcAdrTab
		add	a, a
		add	a, l
		ld	l, a
		jr	nc, loc_624B
		inc	h
loc_624B:	ld	a, (hl)
		inc	hl
		ld	h, (hl)
		ld	l, a
		ex	(sp), hl
		ret
		
funcAdrTab:	dw initGame		; 00: init game
		dw goGame		; 01: start game itself
		dw fArrOn		; 02: draw cursor
		dw fArrOff		; 03: remove cursor
		dw getArrowKPos		; 04: HL=arrowXY, CY:fire pressed
		dw gameOver		; 05: do game over C (4:final)
		dw setMapC		; 06: set map C
		dw getTile		; 07: D = tile from (map B coord C)
		dw putTile		; 08: put tile D at (map B coord C)
		dw getDirMap		; 09: D = map in dir (H = FC..FF) of map B
		dw drawTileM
		dw drawTile		; 0B: draw tile D on coord C
		dw fillMapCol		; 0C: fill map with atr C (0:default)
		dw loc_65B7
		dw addExpa		; 0E: add exerience
		dw getDamage		
		dw doAttack		; 10
		dw outNpcHealth
		dw setMuzic		; 12: set music C
		dw playMuz		; 13
engFuncMax	equ ($-funcAdrTab)/2
; ---------------------------------------------------------------------------
playMuz:				; RAM:6277o
		ld	a, (curBank)
		push	af
		ld	a, 4
		call	setBank
		call	p1.muzPlay
		pop	af
		jp	setBank
		
; start music C
setMuzic:	ld	a, 37h
		ld	(muzFlag), a
		ld	a, 4
		call	setBank
		push	bc
		call	p1.muzMute
		pop	bc
		ld	hl, muzTab
		ld	b, 0
		add	hl, bc
		add	hl, bc
		ld	a, (hl)
		inc	hl
		ld	h, (hl)
		ld	l, a
		ld	de, (muzFAdr)
		push	de
		call	deHrust2
		pop	hl
		push	ix
		call	p1.muzInit
		pop	ix
		ld	a, 0A7h
		ld	(muzFlag), a
		ei
		ret
		
callEngineFunc:	ex	af, af'
		ld	a, (curBank)
		push	af
		ex	af, af'
		push	ix
		call	callFunc
		pop	ix
		ex	af, af'
		pop	af
		call	setBank
		ex	af, af'
		ret

; call extend function A. (in banks 0, 1, 3)
callExt0:	push	hl
		ld	l, 0
		jr	loc_62E5
callExt1:	push	hl
		ld	l, 1
		jr	loc_62E5
callExt3:	push	hl
		ld	l, 3
loc_62E5:	push	af
		ld	a, (curBank)
		ld	h, a
		ld	a, l
		call	setBank
		pop	af
		ex	(sp), hl
		push	ix
		call	0xc000
		pop	ix
		ex	(sp), hl
		push	af
		ld	a, h
		call	setBank
		pop	af
		pop	hl
		ret
		
initGame:	di
		ld	hl, 6000h
		ld	de, 6001h
		ld	bc, 100h
		ld	a, h
		ld	i, a
		inc	a
		ld	(hl), a
		ldir
		im	2
		xor	a
		out (0xfe),a
		ld	(curItem), a
		ld	(spellsCnt), a
		ld	(curSpell), a
		ld	bc, 2621h
		ld	d, 0EFh
		ld	a, 8
		call	ovEngineFunc
		ld	a, 6
		call	setBank
		ld	a, 33h
		call	getMapAdr
		ld	a, l
		add	a, 0Ah
		ld	l, a
		ld	de, 0DBDCh
		ld	a, 0D1h
		call	sub_6368
		inc	hl
		inc	hl
		inc	hl
		inc	hl
		inc	hl
		call	sub_6368
		ld	a, 39h
		call	getMapAdr
		ld	a, l
		or	14h
		ld	l, a
		ld	(hl), 0DBh
		inc	l
		ld	(hl), 0D1h
		inc	l
		ld	(hl), 0DCh
		ld	a, 4Bh
		call	getMapAdr
		ld	a, l
		or	0Ch
		ld	l, a
		ld	(hl), 0E7h
		pop	hl
		ld	(loc_6388+1), sp
		ei
		jp	(hl)

sub_6368:	ld	(hl), d
		inc	hl
		ld	(hl), a
		inc	hl
		ld	(hl), a
		inc	hl
		ld	(hl), e
		ret

; prepare to quit the game
exitGame:	di
		call	aniOff
		ld	a, 5
		call	ovFuncExt0
		ld	a, 3Fh
		ld	i, a
		im	1
		ld	hl, 2762h
		exx
		ld	iy, 5C3Ah
		pop	hl
loc_6388:	ld	sp, 0
		ei
		ret
		
goGame:	ld	a, 37h
		ld	(loc_61CE), a
		call	initGame
		call	aniOff
		call	cls
		xor	a
		call	ovFuncExt0
		xor	a
		call	ovFuncExt1
		ld	a, 3
		call	ovFuncExt3
		ld	a, 4
		call	ovFuncExt0
		ld	c, 1
		ld	a, 12h
		call	ovEngineFunc
		ld	ix, npcTab
		ld	c, 0
		call	setMapC
		ld	d, 0
		call	addExpa
		call	aniOn
		ld	b, 1
		ld	c, 0
		ld	a, 2
		call	ovFuncExt0
		ld	b, 1
		ld	a, 9
		call	ovFuncExt0
		ld	b, 1
		ld	a, 3
		call	ovFuncExt1
		ld	b, 1
		ld	c, 1
		ld	a, 2
		call	ovFuncExt0
loc_63E5:	call	inputKey
		and	a
		call	z, fatalErr
		ld	c, a
		ld	hl, stru_6408
loc_63F0:	ld	a, (hl)
		and	a
		jr	z, loc_63E5
		cp	c
		inc	hl
		jr	z, loc_63FC
		inc	hl
		inc	hl
		jr	loc_63F0
loc_63FC:	ld	a, (hl)
		inc	hl
		ld	h, (hl)
		ld	l, a
		ld	(loc_6403+1), hl
loc_6403:	call	0
		jr	loc_63E5
; ---------------------------------------------------------------------------
stru_6408:	IDADR 51h, loc_6428
		IDADR 41h, loc_642C
		IDADR 4Fh, loc_6430
		IDADR 50h, loc_6434
		IDADR 20h, loc_6418
		db 0
; ---------------------------------------------------------------------------
loc_6418:	call	fNoFire
loc_641B:	ld	a, 4
		call	ovFuncExt3
		jr	c, loc_641B
		call	fNoFire
		jp	rmArrow
; ---------------------------------------------------------------------------
loc_6428:	ld	h, 1
		jr	loc_6436
loc_642C:	ld	h, 0
		jr	loc_6436
loc_6430:	ld	h, 2
		jr	loc_6436
loc_6434:	ld	h, 3
loc_6436:	ld	a, (heroId)
		ld	b, a
loc_643A:	ld	a, 8		; C = (+3) of NPC B
		call	ovFuncExt0
		ld	a, c
		cp	h
		jr	z, loc_644F
		ld	c, h
		ld	a, 3
		call	ovFuncExt0
		ld	b, 0Ah
loc_644B:	halt
		djnz	loc_644B
		ret
loc_644F:	ld	a, 2
		call	ovFuncExt0
		ld	a, 9
		jp	ovFuncExt0
		
inputKey:	call	arrInput
		bit	4, c
		ld	a, 20h
		ret	nz
		ld	hl, keyTab_6472
loc_6464:	ld	a, (hl)
		and	a
		jr	z, inputKey
		inc	hl
		in	a, (0FEh)
		and	(hl)
		inc	hl
		ld	a, (hl)
		ret	z
		inc	hl
		jr	loc_6464

keyTab_6472:	db 0FBh, 1, 51h
		db 0EFh, 8, 51h
		db 0FDh, 1, 41h
		db 0EFh, 10h, 41h
		db 0DFh, 1, 50h
		db 0EFh, 4, 50h
		db 0DFh, 2, 4Fh
		db 0F7h, 10h, 4Fh
		db 0

waitKey:	xor	a
		in	a, (0FEh)
		cpl
		and	1Fh
		jr	z, waitKey
		ret

noKey:		xor	a
		in	a, (0FEh)
		cpl
		and	1Fh
		jr	nz, noKey
		ret
		
noFire:		call	arrInput
		bit	4, c
		jr	nz, noFire
		ret
		
cls:		ld	hl, 4000h
		ld	de, 4001h
		ld	bc, 1800h
		ld	(hl), l
		ldir
		ld	bc, 2FFh
		ld	(hl), 7
		ldir
		xor	a
		out	(0FEh),	a
		ret
		
; fight: print NPC B health bar on #5248

outNpcHealth:	ld	a, 0
		call	setBank
		push	ix
		ld	ix, npcTab
		ld	de, 20h
loc_64CA:	ld	a, (ix+0)
		cp	0FFh
		call	z, fatalErr
		cp	b
		jr	z, loc_64D9
		add	ix, de
		jr	loc_64CA
loc_64D9:	ld	a, (ix+5)
		jr	loc_6511
		
; fight : attack NPC B, damage = (3+STR)

doAttack:	ld	a, 0
		call	setBank
		ld	a, (ix+6)
		rra
		rra
		rra
		rra
		and	0Fh
		push	ix
		push	af
		ld	ix, npcTab
		ld	de, 20h
loc_64F6:	ld	a, (ix+0)
		cp	0FFh
		call	z, fatalErr
		cp	b
		jr	z, loc_6505
		add	ix, de
		jr	loc_64F6
loc_6505:	ld	a, (ix+5)
		pop	de
		sub	d
		jr	c, loc_6510
		sub	3
		jr	nc, loc_6511
loc_6510:	xor	a
loc_6511:	ld	hl, 5248h
		ld	(ix+5),	a
		call	outBar
		ld	a, (ix+5)
		pop	ix
		ret
		
; fight : get D damage

getDamage:	ld	a, 0
		call	setBank
		ld	a, (ix+5)
		sub	d
		jr	nc, loc_652C
		xor	a
loc_652C:	ld	(ix+5),	a
		call	outStatBars
		ld	a, (ix+5)
		ld	hl, 5246h
		call	outBar
		ld	a, (ix+5)
		and	a
		ret

; add D experience

addExpa:	ld	a, 0
		call	setBank
		ld	a, (ix+6)
		add	a, d
		jr	nc, loc_654D
		ld	a, 0FFh
loc_654D:	ld	(ix+6),	a
		call	outStatBars
		ld	a, (ix+6)
		ret
		
; print VIT/STR/EXP bars

outStatBars:	ld	hl, 4A92h
		ld	a, (ix+5)
		call	outBar
		ld	hl, 4A93h
		ld	a, (ix+6)
		rrca
		rrca
		rrca
		and	1Eh
		call	outBar
		ld	hl, 4A94h
		ld	a, (ix+6)
		add	a, a
outBar:		and	1Fh		; out bar. HL = adr; A = value
		ld	d, a
		ld	b, 1Ch
		ld	c, 38h
loc_657C:	ld	a, b
		cp	d
		ld	a, c
		jr	c, loc_6582
		xor	a
loc_6582:	ld	(hl), a
		inc	h
		ld	a, h
		and	7
		jr	nz, loc_6593
		ld	a, l
		add	a, 20h
		ld	l, a
		jr	c, loc_6593
		ld	a, h
		sub	8
		ld	h, a
loc_6593:	ld	a, c
		xor	0Ch
		ld	c, a
		djnz	loc_657C
		ret
		
gameOver:	ld	a, 37h
		ld	(loc_61CE), a
		call	aniOff
		ld	a, c
		cp	4
		push	bc
		call	nz, sub_66FC
		ld	b, 32h
loc_65AB:	halt
		djnz	loc_65AB
		pop	bc
		ld	a, 1
		call	ovFuncExt1
		jp	exitGame
		
loc_65B7:	ld	a, 0
		call	setBank
		push	de
		call	findNpc
		call	c, fatalErr
		pop	de
		ld	(ix+13h), d
		ld	(ix+14h), e
		ld	(ix+4),	0FEh
		set	5, (ix+1Dh)
		set	6, (ix+1Dh)
		ld	(ix+1Fh), 0
		ret

; get direction map.nr (H = FC..FF, B = cur.map.nr)

getDirMap:	ld	a, (curBank)
		push	af
		ld	a, 6
		call	setBank
		ld	l, b
		ld	d, (hl)
		pop	af
		jp	setBank
		
; put | get tile.nr
; B = map.nr, C = coord, [D = tile.num]

putTile:	ld	a, 72h
		jr	loc_65F0
getTile:	ld	a, 56h
loc_65F0:	ld	(loc_6603), a
		ld	a, (curBank)
		push	af
		ld	a, 6
		call	setBank
		ld	a, b
		call	getMapAdr
		ld	a, l
		add	a, c
		ld	l, a
loc_6603:	nop
		pop	af
		jp	setBank
		
setMapC:	ld	a, (aniFlag)		; go to map C
		push	af
		call	aniOff
		push	bc
		ld	a, 5			; remove all NPC
		call	ovFuncExt0
		pop	bc
		ld	a, c
		ld	(curMapNr), a
		cp	64h
		jr	nz, loc_6649
		ld	de, 4021h		; map 100 : final fight (draw picture)
		ld	hl, byte_958C
		ld	b, 10h
loc_6626:	push	de
		push	bc
		ld	bc, 10h
		ldir
		pop	bc
		pop	de
		inc	d
		ld	a, d
		and	7
		jr	nz, loc_6626
		ld	a, e
		add	a, 20h
		ld	e, a
		jr	c, loc_663F
		ld	a, d
		sub	8
		ld	d, a
loc_663F:	djnz	loc_6626
		ld	a, 6
		call	setBank
		jp	loc_66B8
loc_6649:	ld	hl, byte_6700	; map.id, item.id, <adr>; if map.id & don't got item.id... (dark cave w/o light)
loc_664C:	ld	a, (hl)
		inc	hl
		cp	0FFh
		jr	z, drawMap
		cp	c
		jr	z, loc_6659
		inc	hl
		inc	hl
		jr	loc_664C
loc_6659:	push	bc
		ld	c, (hl)
		ld	a, 0Eh
		call	ovFuncExt0
		pop	bc
		jp	nz, loc_66D1
drawMap:	ld	a, 6		; draw map C
		call	setBank
		ld	a, c
		call	getMapAdr
		ld	(curMapAdr), hl
		ld	de, 4021h
		ld	b, 8
loc_6675:	ld	c, 8
		push	de
loc_6678:	push	bc
		push	de
		push	hl
		ld	l, (hl)
		ld	h, 0
		add	hl, hl
		add	hl, hl
		add	hl, hl
		add	hl, hl
		add	hl, hl
		ld	bc, tilesData
		add	hl, bc
		ld	bc, 2FFh
loc_668A:	ldi
		ldi
		dec	e
		dec	e
		inc	d
		ld	a, d
		and	7
		jr	nz, loc_668A
		ld	a, e
		add	a, 20h
		ld	e, a
		jr	c, loc_66A0
		ld	a, d
		sub	8
		ld	d, a
loc_66A0:	djnz	loc_668A
		pop	hl
		pop	de
		pop	bc
		inc	hl
		inc	e
		inc	e
		dec	c
		jr	nz, loc_6678
		pop	de
		ld	a, e
		add	a, 40h
		ld	e, a
		jr	nc, loc_66B6
		ld	a, d
		add	a, 8
		ld	d, a
loc_66B6:	djnz	loc_6675
loc_66B8:	ld	a, 4
		call	ovFuncExt0
		ld	a, (curMapNr)
		ld	l, a
		ld	h, 0FBh
		ld	a, (hl)
		and	a
		jr	nz, loc_66C9
		ld	a, 6
loc_66C9:	call	sub_6714
		pop	af
		ld	(aniFlag), a
		ret
loc_66D1:	inc	hl		; set hero ani : enter-exit dark cave
		ld	a, (hl)
		push	af
		call	sub_66FC
		pop	af
		ld	c, a
		ld	b, 0
		ld	a, 2
		call	ovFuncExt0
		res	6, (ix+1Dh)
		res	5, (ix+1Dh)
		call	aniOn
		ld	a, 4
		call	ovFuncExt0
		ld	b, 0
		ld	a, 9
		call	ovFuncExt0
		pop	af
		ld	(aniFlag), a
		ret
		
byte_6700:	db 11h,	1, 5		; setMapC:loc_6649o
		db 0FFh

sub_66FC:	ld	c, 40h
fillMapCol:	ld	a, c		; fill map with color C (0:default)
		and	a
		jr	nz, sub_6714
		ld	a, 6
		call	setBank
		ld	a, (curMapNr)
		ld	l, a
		ld	h, 0FBh
		ld	a, (hl)
sub_6714:	ld	hl, 5821h
		ld	de, 10h
		ld	b, 10h
loc_671C:	ld	c, 10h
loc_671E:	ld	(hl), a
		inc	l
		dec	c
		jr	nz, loc_671E
		add	hl, de
		djnz	loc_671C
		ret

; draw tile with mask D on coord C (0..3F)

drawTileM:	call	mapCrd2scrAdr
		push	hl
		ld	l, d
		ld	h, 0
		add	hl, hl
		add	hl, hl
		add	hl, hl
		add	hl, hl
		add	hl, hl
		add	hl, hl
		ld	de, mTilesData
		add	hl, de
		pop	de
		ld	b, 2
loc_673B:	ld	a, (de)
		and	(hl)
		inc	hl
		or	(hl)
		ld	(de), a
		inc	e
		inc	hl
		ld	a, (de)
		and	(hl)
		inc	hl
		or	(hl)
		ld	(de), a
		inc	hl
		dec	e
		inc	d
		ld	a, d
		and	7
		jr	nz, loc_673B
		ld	a, e
		add	a, 20h
		ld	e, a
		jr	c, loc_6759
		ld	a, d
		sub	8
		ld	d, a
loc_6759:	djnz	loc_673B
		ret

; draw tile D on coord C (0..3F)

drawTile:	call	mapCrd2scrAdr
		push	hl
		ld	l, d
		ld	h, 0
		ld	de, tilesData
		add	hl, hl
		add	hl, hl
		add	hl, hl
		add	hl, hl
		add	hl, hl
		add	hl, de
		pop	de
		ld	bc, 2FFh
loc_6770:	ldi
		ldi
		dec	e
		dec	e
		inc	d
		ld	a, d
		and	7
		jr	nz, loc_6770
		ld	a, e
		add	a, 20h
		ld	e, a
		jr	c, loc_6786
		ld	a, d
		sub	8
		ld	d, a
loc_6786:	djnz	loc_6770
		ret

; map coord (C = 0..3F) -> scr.adr of this tile

mapCrd2scrAdr:	ld	a, c
		and	7
		add	a, a
		inc	a
		ld	b, a
		ld	a, c
		rra
		rra
		and	0Eh
		inc	a
		ld	c, a
		rrca
		rrca
		rrca
		and	0E0h
		or	b
		ld	l, a
		ld	a, c
		and	18h
		or	40h
		ld	h, a
		ret

; get map A adr
; HL = 0xc000 + 0x40 * A

getMapAdr:	ld	h, a
		ld	l, 0
		scf
		rr	h
		rr	l
		scf
		rr	h
		rr	l
		ret
		
		ld	a, (curBank)		; ???
		push	af
		ld	a, 0
		call	setBank
		ex	af, af'
		call	ovFuncExt0
		pop	af
		
setBank:	push	bc
		and	7
loc_67C3:	or	10h
		ld	(curBank), a
		ld	bc, 0x7FFD
		out	(c), a
		pop	bc
		ret

backupScr:	ld	a, 7
		call	setBank
		ld	hl, freeSpace
		ld	de, 0C000h
		ld	bc, 1B00h
		ldir
		ld	a, 3
		jp	setBank

		include "arrow.asm"
		include "dehrust2.asm"
		
tilesData:	incbin "tiles.bin"		; 2x2: 32 bytes
mTilesData:	incbin "tilesM.bin"		; 2x2: 64 bytes = 32 x {mask, byte}
itemsData:	incbin "items.bin"
byte_958C:	incbin "pentagram.16x16.bin"	; 16x16

freeSpace:	equ $

		display "engine\t",spnt,",",$-spnt
		savebin "obj/main.bin",spnt,$-spnt

; ----------------------------------

	SAVESNA "vq2.sna",begin